/* iNomads.js -- Javascript for iNomads
 * 
 * (C) copyright 2007-2009, Business Basic Systems Corporation
 * Licensed to PVX Plus Technologies Ltd., Ontario, Canada
 * All rights reserved worldwide.
 * Unauthorized use of this code is strictly prohibited.
 */

var chg_id = '';
var chg_val = '';
var sig_id = '';

var wdwParent = null;

var oFcs;	// Object that has focus
var oTrap = null;
var oChg = null;
var sFcsId;  // Ctl id for focus
var sFcsPend = '';

var cur_kc = 0;
var sFmt = '';
var sLog = '';
var bIgnoreFcs = 0;
var bSkipOnFocus = 0;	// Set when no need to send focus to host
var bIsCommon = false;
var oCellEdit = null;
var nNumber = 0;

var sPending = '';
var sPendLast = '';

var nSubmit = 0;
var sSubmit = '';

var iNmd_is_ie = 0;
var iNmd = null;

var nMseX = 0;
var nMseY = 0;
var oMnuDiv = null;

var wdwWd;
var wdwHi;
var bdyWd;
var bdyHi;
var pnlWd;
var pnlHi;

var oStamp;
var nPoll = 0;
var nPollTime = 60;

var bSetSize = false;
var bShrink = false;

var bAutoFolder = false;
var nMaxFolder = 11101;
var nMinFolder = 11001;

var bResize = false;
var bIgnUnload = false;
var sTabFcs = null;
var bTrapped = false;
var bRefocus = false;
var bIdleReqd = false;
var bFldrPend = false;

var nDblClkMS = 1000;
var nClickMS = 0; 
var oClick = null;

function submitform(ctl_id) { iNmd_Send(ctl_id); } /* Old */

function iNmd_Send(ctl_id)
{	if (bIdleReqd)
	{	bIdleReqd = false;
		AjxSend('I', 1);
	}

	document.inomads._ctl_id.value = ctl_id;

	window.onbeforeunload = null;
	window.onunload = null;
	document.inomads.submit();
}

/* Generic focus handling and signalling logic */

function iNmd_focus(oFcsNew)
{	if (oDivMbox) return;
	if (oDivMask)
	{	i_Id('id_Dead').focus();
		return;
	}
	if (bIgnoreFcs) 
	{	bIgnoreFcs = 0;
		return;
	}

	if (bPopup) return;

	if (oMnuDiv) iMnu_Clear();

	if (oFcs && (oFcs == oFcsNew)) return;	/* No change */

	/* If Server didn't send us here check current focus
		- Check rules to see if focus chg ok
		- Set pending new focus to go to host
		- Process any changes
	 */
	
	if ((oFcs) && (oFcs != oFcsNew))
	{	if (!iNmd_Valid()) return; 
	}
	
	sFcsPend = oFcsNew.id.substr(3);	

	if (oFcs)
	{	if (oFcs.in_autopend) iNmd_Auto();
	
		if (oFcs.in_blur) oFcs.in_blur(oFcs);

		if (!oChg && oFcs.in_oldval)
		{	if (oFcs.in_oldval != iNmd_Val(oFcs)) oChg = oFcs;
		}

		if (oChg) iNmd_Chg(oChg);
	}

	iNmd_SetFcs(oFcsNew);

	if (sFcsPend != '')  AjxSend('', 0);

	return;
}

function iNmd_SetFcs(oFcsNew)
{	oChg = null;
		
	document.inomads._eom.value = '';
	oFcs = oFcsNew;

	if ((oFcs.in_retry) || (oFcs.in_sigexit == 1))
	{	oChg = oFcs;
		oFcs.in_retry = false;
	}
	
	if (oFcs.in_fmt) sFmt = oFcs.in_fmt;

	sFcsId = oFcs.id.substr(3);
	document.inomads._fcs_id.value =  sFcsId;

	if (oFcs.className == 'iCmnVal')
	{	bIsCommon = true;
	}
	else
	{	bIsCommon = false;
	}

	oFcs.in_oldval = iNmd_Val(oFcs);
}

function iNmd_SetVal(sId, sVal)
{	var oObj = i_Id(sId);
	if (oObj)
	{	oObj.value = sVal;
		oObj.in_oldval = ':' + sVal;
	}
	return;
}

function iNmd_Auto()
{	if (!oFcs.in_autopend) return;
	oFcs.in_autopend = false;
	
	var sVal = iNmd_Val(oFcs);
	if (oFcs.in_oldval == sVal) return;

	oFcs.in_oldval = sVal;

	if (oFcs.in_fcsId) sVal += '#' + oFcs.in_fcsId;
	
	AjxSend('C' + oFcs.id.substr(3) + ',0' + sVal, 0);
	oChg = null;
	return;
}

function iKey(e)
{	if (!iNmd_is_ie)
		return e.which;
	else
		return e.keyCode;
}			
	
function iNmd_Chg(oCtl, cType)
{	var sVal;
    var chEom;
    var nEom;
    
	if (!oCtl) return;
	if (!cType) cType = 'C';

	if (cType != 'U') oChg = null;
	
    chEom = document.inomads._eom.value;
    if (chEom == '') 
		nEom = 0;
    else
		nEom = chEom.charCodeAt(0);

    if (oCtl.id.substr(0,3) == 'rb_') oCtl = iNmd_RbtVal(oCtl);

	sVal = iNmd_Val(oCtl);
	oCtl.in_oldval = sVal;
	
    if (oCtl.in_fcsId) sVal += '#' + oCtl.in_fcsId;
    
	AjxSend(cType + oCtl.id.substr(3) + ',0' + nEom + sVal, 1);
	return;
}

function iNmd_TabOut(e)
{	if (e.shiftKey)
		document.inomads._eom.value = '\x19';
	else
		document.inomads._eom.value = '\t';

	sTabFcs = '*';
	setTimeout(iNmd_TabSnd, 50);
	
	if (oFcs)
	{	iNmd_TabTrap();
		if (iNmd_is_ie) iNmd_IE_deselect();
	}

	if (e.stopPropagation) e.stopPropagation();
	if (e.preventDefault) e.preventDefault();
	e.cancelBubble = true;
    e.cancel = true;
	e.returnValue = false;
		 
	return false;
}

function iNmd_TabTrap()
{	if (!oTrap)
	{	oTrap = i_Id("id_Trap");
		if (!oTrap) return;
	}
	oTrap.focus();
	bTrapped = true;
}

function iNmd_TabSnd()
{	if (!oFcs) alert('Tab with no focus');

	if (!iNmd_Valid())
	{	document.inomads._eom.value = '';
		sTabFcs = null;
		return;
	}

	if (oChg)
	{	iNmd_Chg(oChg);
	}
	else
	{	var cTab = document.inomads._eom.value;
		if (cTab == '') cTab = '\t';
		AjxSend('C,' + cTab.charCodeAt(0), 0);
	}
	return;
}
	
function iNmd_KdnChkTab(e)
{	if (window.event) e = window.event;

	if (iKey(e) == 9)
	{	//var oCtl = (e.target ? e.target : e.srcElement);
		return iNmd_TabOut(e);
	}
	return true;
}

function iNmd_IE_deselect()
{	if (oFcs.type == 'text') document.selection.empty();
	return;
}	

function iNmd_Val(oObj)
{	if (!oObj.type) return '';

	if ((oObj.type == 'text') || (oObj.type == 'textarea') || (oObj.type == 'hidden') || (oObj.type == 'password'))
		return ':' + oObj.value;
	
	if (oObj.type.substr(0,6) == 'select')
	{	var sVal = ':';
  
		var  nIdx = 0;
		while (nIdx < oObj.length)
		{	if (oObj.options[nIdx++].selected) sVal = sVal + nIdx + ',';
		}
		return sVal;
	}
	return '';
}

function iNmd_Restore(oObj)
{	oChg = null;			/* Toss any pending */

	if (!oObj.in_oldval) return;
	if (!oObj.type) return;

	if ((oObj.type == 'text') || (oObj.type == 'textarea') || (oObj.type == 'hidden') || (oObj.type == 'password'))
	{	oObj.value = oObj.in_oldval.substr(1);
	}
	else
	if (oObj.type.substr(0,6) == 'select')
	{	iNmd_LbxSel(oObj.id, oObj.in_oldval.substr(1));
	}
	return;
}
	
function iNmd_Pend()
{	if (oMnuDiv) iMnu_Clear();

	iNmd_Send(sPending);
	sPendLast = '';
	sPending = '';
}

function iNmd_Submit(msg_id)
{	if (oMnuDiv) iMnu_Clear();

	nSubmit++;
	sSubmit = msg_id;
	
	if (bFldrPend && (msg_id == 'RESET')) return;
	
	if (sPending == '')
	{	iNmd_Send(msg_id);
	}
	else
	{	iNmd_Queue(msg_id);
	}
}

function iNmd_Queue(msg_id)
{ if (sPendLast == msg_id) return;
  sPendLast = msg_id;

  if (sPending == '')
   { sPending = msg_id;
     setTimeout(iNmd_Pend, 350);
   }
   else
   { sPending += ';' + msg_id;
   }
}

/* Firefox specific logic for Wheel */

var bFireFox = false;
var bOpera = false;
var bSafari = false;
var bBerry = false;
var bChrome = false;
var bIphone = false;
var sRev = 'inomads.js Rev: Dec 1/09b ';

function iNmd_MseWhl(event)
{	var oFld;

	oFld = event.target;
	while (oFld)
	{	if (oFld.id)
		{	if (oFld.id.substr(0,3) == 'dv_')
			{	if (event.stopPropagation) event.stopPropagation();
				if (event.preventDefault) event.preventDefault();
				event.cancelBubble = true;
				event.cancel = true;
				event.returnValue = false;
				iNmd_CmnWhl(oFld.id.substr(3,5), event);
				return false;
			}
		}

		oFld = oFld.parentNode;
	}
	return true;
}

function iNmd_RMseOpera(event)
{	if (event.altKey)
	{ var oNode = event.target;
		var oHtml;
		var nOfs; 
	    
		if (oNode == window) return iNmd_Context(e);
		
		while (oNode)
		{	oHtml = oNode.outerHTML;
			nOfs = oHtml.indexOf("oncontextmenu=");
			if (nOfs > 0) break;
		    
			if (oNode.nodeName == 'TABLE') break;
			oNode = oNode.parentNode;
		}
	    
		if (nOfs > 0)
		{	var sDlm = oHtml.substr(nOfs+14,1);
			var sCmd = '';

			oHtml = oHtml.substr(nOfs + 15);

			while (1)
			{	nOfs = oHtml.indexOf(sDlm);
				if (nOfs < 1) break;
		        
				if (oHtml.charAt(nOfs - 1) != '\\') break;
		        
				sCmd += oHtml.substr(0,nOfs-1) + sDlm;
				oHtml = oHtml.substr(nOfs+1);
			}
		    
			if (nOfs >= 0)
			{	sCmd += oHtml.substr(0, nOfs);
				Function(sCmd)();
			}
		}
		return false;
	}
	return true;
}

function iNmd_init(idStrt, nPollTm)
{	var oStart;
	if (nPollTm) nPollTime = nPollTm;
	
	iNmd = document.inomads;
	oStamp = i_Id('iNmdScript');

	try
	{	if (window.opener)
			wdwParent = window.opener.iNmd_HiMom(window);
	}
	catch(err)
	{	wdwParent = null;
	}
	
	if (window.focus) window.focus();
	
	if (document.selection)
	{  iNmd_is_ie = 1;
		if (window.opera)
		{	sRev += '(Opera)';
			window.addEventListener('mousedown', iNmd_RMseOpera, false);
			bOpera = true;
			iNmd_is_ie = 0;
		}
		else 
		{	sRev += '(MSIE)';
		}
	}
	else
	{	iNmd_is_ie = 0;
		if (navigator.userAgent.indexOf("Firefox") != -1)
		{	window.addEventListener('DOMMouseScroll', iNmd_MseWhl, true);
			sRev += '(Firefox)';
			bFireFox = true;
			
			for (var nElm = 0; nElm < document.inomads.elements.length; nElm++)
			{	if (document.inomads.elements[nElm].type.substr(0,6) == 'select')
				{	document.inomads.elements[nElm].in_oldval = iNmd_Val(document.inomads.elements[nElm]);
				}
			}
			
		}
		else
		if (navigator.userAgent.indexOf("Chrome") != -1)
		{	bChrome = true;
			sRev += '(Chrome)';
			nDblClkMS = 3000;
		}
		else
		if (navigator.userAgent.indexOf("Apple") != -1)
		{	bSafari = true;
			if (navigator.userAgent.indexOf("iPhone") == -1)
				sRev += '(Safari)';
			else
			{	sRev += '(iPhone)';
				bIphone = true;
				nDblClkMS = 5000;
			}
		}
		else
		if (navigator.userAgent.indexOf("BlackBerry") != -1)
		{	bSafari = true;
			bBerry = true;
			if (navigator.userAgent.indexOf("erry95") == -1)
				sRev += '(BlackBerry)';
			else
			{	sRev += '(BB-Storm)';
				bIphone = true;
				nDblClkMS = 5000;
			}
		}
	}

	window.onbeforeunload = iNmd_B4Unload;
	
	if (!bSafari)
	{	window.onunload = iNmd_Unload;
	}	

	if (!bOpera) i_Id('id_Main').oncontextmenu = iNmd_Context;
	
	if (oStamp)
	{	oStamp.innerHTML = '<a href="#" onclick="AjxDump();">' + sRev + '</a>' +
				'<a class="iCmnVal" href="#" tabindex=1000 onfocus="iNmd_TabTrap();">&nbsp;</a>' +
				'<a class="iCmnVal" id="id_Trap" href="#" tabindex=1001>&nbsp;</a>' +
				'<a class="iCmnVal" href="#" tabindex=1002 onfocus="iNmd_TabTrap();">&nbsp;</a>';
	}
	
	if (oStamp && window.opener && bSetSize)
	{	iNmd_GetSize();
		if (wdwWd > 0)
		{	var hiReqd = bdyHi + 10;
			var wdReqd = bdyWd + 10;

			wdReqd -= wdwWd;
			hiReqd -= wdwHi;
				
			if (!bShrink) 
			{	if (wdReqd < 0) wdReqd = 0;
				if (hiReqd < 0) hiReqd = 0;
			}
				
			if (wdReqd || hiReqd) window.resizeBy(wdReqd, hiReqd);		
		}
	}

	if (idStrt != '')
	{	var oFld = i_Id(idStrt);
	
		if (oFld)
		{	iNmd_SetFcs(oFld);
			if (oFld.focus) oFld.focus();
			iNmd_Select(oFld);
		}
	}
	
	if (bIphone) window.scrollTo(0,1);
	setTimeout(iNmd_Settled,500);
}

function iNmd_Tab(e)
{	if (oFcs && oFcs.focus) oFcs.focus();
	return;
}

function iNmd_Context(e)
{	if (window.event) e=window.event;

	var oFld = (e.target ? e.target : e.srcElement);
	while (oFld)
	{	if (oFld.id) 
		{	if (oFld.id.substr(0,6) != 'iFrame') return true;
		}
		
		oFld = oFld.parentNode;
		if (oFld.nodeName == 'TABLE') break;
	}
	
	if (!oFld.id) return true;
	if (oFld.id != 'id_Panel') return true;
	
	if (e.stopPropagation) e.stopPropagation();
	if (e.preventDefault) e.preventDefault();
	
	return iNmd_Menu(e, -1083);
}	
	
function iNmd_B4Unload()
{	if (bIgnUnload) return;

	if ((oChild) && (!oChild.closed))
	{	setTimeout(window.blur,2500);
		return "Please close the child window '"+ oChild.document.title + "' first.";
	}
	if (!wdwParent)
		return "Please use the 'Close' option in the window to assure proper shutdown.";
	
	if (bSafari) iNmd_Unload();
	
	return;
}

function iNmd_Unload()
{	if (oChild && (!oChild.closed))
	{	try
		{	oChild.wdwParent = wdwParent;
		}
		catch(err)
		{
		}
	}
	if (wdwParent && (!wdwParent.closed))
	{	wdwParent.iNmd_ByeMom(document.inomads._seq.value);
	}
	else
	{	AjxSend('QGone', 0);
	}
}

function iNmd_ByeMom(sSeq)
{	AjxSend('Q' + sSeq,0);
}

function iNmd_HiMom(wdwChild)
{	if (wdwChild != oChild) 
		return null;
	else
		return window;
}

function iNmd_Settled()
{	if ((nPendSize != -1) && !bIphone)
		window.onresize = iNmd_Resize;
	
	nPoll = 0;
	setInterval(iNmd_Poll, 60 * 1000);
}	

function iNmd_Poll()
{	if (idMbxTimer) return;

	nPoll++;
	if (nPoll >= nPollTime) 
	{	AjxSend('*',0);
	}
}


/* iNmd_GetSize -- set size */
function iNmd_GetSize()
{	var oPnl = i_Id('id_Panel');
	if (oPnl)
	{	pnlWd = oPnl.offsetWidth;
		pnlHi = oPnl.offsetHeight;
	}
	else
	{	pnlWd = pnlHi = -1;
	}

	wdwWd = wdwHi = -1;
	bdyWd = bdyHi = -1;
	
	if (iNmd_is_ie || bSafari)
	{	var bdy = self.parent.document.body.parentNode;
		wdwWd = bdy.offsetWidth;
		wdwHi = bdy.offsetHeight;
	}
	else
	{	wdwWd = window.parent.innerWidth;
		wdwHi = window.parent.innerHeight;
	}
	
	var oDiv = i_Id('id_Main');
	if (!oDiv) return;
	
	bdyWd = oDiv.offsetWidth;

	if (iNmd_is_ie)
	{	bdyHi = document.body.parentNode.scrollHeight;
	}
	else
	{	bdyHi = document.body.parentNode.offsetHeight;
	}
	
	/* Not perfect should in theory walk all the frame levels */
	
	var oFrame = frameElement;
	if (oFrame)
	{	bdyHi += iNmd_Top(oFrame);
		bdyWd += iNmd_Left(oFrame);
	}

}

/* iNmd_Resize -- send resize to the host */
var nPendSize = 0;

function iNmd_Resize()
{	if (oChild) return;
	
	if (nPendSize != 3)
	{	if (nPendSize == 0) setTimeout(iNmd_SendSize, 200);
		nPendSize = 1;
	}
	return;
}
	
var bMaxMin = 0;

function iNmd_SendSize()
{	if (bMaxMin == 0)
	{	if (nPendSize == 3) return;

		if (nPendSize == 1)	
		{	setTimeout(iNmd_SendSize, 200);
			nPendSize = 2;
			return;
		}
			
		nPendSize = 3;
	}
	
	iNmd_GetSize();
	if (wdwWd < 0) return;

	if (bMaxMin == 2)
	{	iNmd_Submit('Z10,10,10,10,10,10');
	}
	else
	{	iNmd_Submit('Z' + wdwWd + ',' + wdwHi + 
			',' + bdyWd + ',' + bdyHi + ',' + pnlWd + ',' + pnlHi);
	}
	return;
}

function iNmd_MaxMin(nType)
{	bMaxMin = nType;
	iNmd_SendSize();
    if (window.event) e.returnValue = false;
    return false;
}
	
/* iNmd_ChkChr(InputChar, FormatChar)
 * Returns: 0 = Reject, 1=Accept, 2=This is a formating char
 */

function iNmd_ChkChr(cInp, cFmt)
{	if (cFmt == 'x') return 1;
	if (cFmt == cInp) return 1;

	if (cFmt == '0')
	{	if ((cInp >= '0') && (cInp <= '9')) return 1;
		return 0;
	}
	if (cFmt == 'a')
	{	if ((cInp >= 'a') && (cInp <= 'z')) return 1;
		if ((cInp >= 'A') && (cInp <= 'Z')) return 1;
		return 0;
	}
	if (cFmt == 'z')
	{	if ((cInp >= 'a') && (cInp <= 'z')) return 1;
		if ((cInp >= 'A') && (cInp <= 'Z')) return 1;
		if ((cInp >= '0') && (cInp <= '9')) return 1;
		return 0;
	}
	if (cFmt == '#')
	{	if ((cInp >= '0') && (cInp <= '9')) return 1;
		if (cInp == ' ') return 1;
		return 0;
	}
	return 2;
}

function iNmd_fmtchr(e, cNew)
{	var nStrt;
	var nLeng;
	var nOfst;

	var oRng;

	var oFld; 
	var sFld;

	var nOfsHash;
	var nOfsZero;

	var cNewOrig = cNew;

	if ((cNew < 32) && (cNew != 8)) return true;
	    
	if (e.target) oFld = e.target; else oFld = e.srcElement;
	if (oFld.nodetype == 3) oFld = oFld.parentNode;

	sFld = oFld.value;

	if (sFld.length > sFmt.length) // Force correction
	{	oFld.value = sFld.substr(0,sFmt.length);
		return false;
	}

	if ((document.selection) && (!bOpera))
	{	oRng = document.selection.createRange();

		nLeng = oRng.text.length;

		nOfst = oRng.moveEnd("character", sFld.length);
		nStrt = sFld.length - oRng.text.length;

		if (nOfst != 0) oRng.moveEnd("character", 0 - nOfst);
	}
	else
	{	nStrt = oFld.selectionStart;
		nLeng = oFld.selectionEnd - nStrt;
	}

	nOfst = nStrt + nLeng;

	if (cNew == 8)
	{	if (nLeng == 0)
		{	if (nStrt == 0) return false;
			nStrt--;
		}
	}

	nOfsHash = sFmt.indexOf('#');
	nOfsZero = sFmt.indexOf('0');
	if (nOfsZero == -1) nOfsZero = sFmt.length + 1;

	if (nOfsHash != -1)
	{	if (nOfsHash < nOfsZero)
		{ return iNmd_numchr(cNew, oFld, oRng, nStrt, nLeng);
		}

		/* We have a # after a zero */

		if (nOfst == sFld.length)
		{	if ((nLeng == 0) || (nStrt == 0)) 
			return iNmd_digapnd(cNew, sFmt, oFld, oRng);
		}
	}

	if (nLeng == 0) nLeng = 1;

	var sRepl = '';
	var nRepl = 0;
	var chRepl = '';
	var bSts = 0;
	var nChrAdj = 1;

	for (nOfst = 0; nOfst < nLeng; nOfst++)
	{	var chFmt = sFmt.charAt(nOfst + nStrt);

		if ((cNew == 127) || (cNew == 8))
		{	if ((chFmt == '0') || (chFmt == '#'))
				chRepl = '0';
			else
			if ('AaXxZz'.indexOf(chFmt) != -1)
				chRepl = ' ';
			else 
				chRepl = chFmt;
		}
		else
		{	chRepl = String.fromCharCode(cNew);
    
			if ('AXZ'.indexOf(chFmt) != -1) 
			{	chFmt = chFmt.toLowerCase();
				chRepl = chRepl.toUpperCase();
			}

			bSts = iNmd_ChkChr(chRepl,chFmt);

			if (bSts == 0) return false; // Bad character
			if (bSts == 2)
			{	chRepl = chFmt;
				nChrAdj++;       
				if (nLeng < sFmt.length) nLeng++;
			}
			else
				cNew = 127; // Delete reset rest of selection
				
			nRepl++;
		}
		sRepl += chRepl;
	}

	sRepl = oFld.value.substring(0, nStrt) + sRepl + oFld.value.substring(nStrt + sRepl.length, oFld.value.length);

	if ((cNewOrig == 8) || (cNewOrig == 127)) nChrAdj = 0;

	if (oRng)
	{	oRng.expand("textedit");
		oRng.text = sRepl;
		oRng.moveEnd("character", 0 - sRepl.length);
		oRng.moveStart("character", nStrt + nChrAdj);
		oRng.select();
	}
	else
	{	oFld.value = sRepl;
		oFld.selectionStart = nStrt + nChrAdj;
		oFld.selectionEnd = nStrt + nChrAdj;
	}
	return false; 
}

function iNmd_numchr(cNew, oFld, oRng, nStrt, nLeng)
{	var sNew;
	var nSign;
	var nValue;
	var nScale;
	var nOfst;
	var chNew;
	var chFmt;
	var nPos;
	var nReqScale;
	var nDigit;
	var bImpliedDP = false;

	if ((cNew == 8) || (cNew == 127)) 
	{	sNew = '';
		if (nLeng == 0) 
		{	if (oFld.value.charAt(nStrt) == chDecimal) nStrt--;
			nLeng = 1;
		}
	}
	else
	{	sNew = String.fromCharCode(cNew);
		if (nLeng <= 1)
		{	if (sNew == oFld.value.charAt(nStrt))
			return iNmd_FmtPos(oRng, oFld, nStrt+1, oFld.value);
		}

		if ((sNew == chDecimal) && (oFld.value.charAt(nStrt + nLeng) == chDecimal)) nLeng++;
	}

	nReqScale = 0;

	nOfst = sFmt.indexOf('.');
	
	if (nOfst != -1)
	{ for(;nOfst < sFmt.length;)
		{	chFmt = sFmt.charAt(nOfst++);
			if ((chFmt == '0') || (chFmt == '#')) nReqScale++;
		}
	}

	if (sFmt.charAt(0) == '\t')
	{	if ((nStrt + nLeng) == oFld.value.length) bImpliedDP = true;
	}

	sNew = oFld.value.substring(0, nStrt) + sNew + oFld.value.substring(nStrt + nLeng, oFld.value.length);

	nScale = -1000;
	nSign = 0;
	nValue = 0;
	nPos = 0;

	for (nOfst = 0; nOfst < sNew.length;)
	{	chNew = sNew.charAt(nOfst++);

		if (chNew == ' ') continue;
		if (chNew == chCurrency) continue;
		if (chNew == chThousand) continue;
		if (chNew == chDecimal)
		{	if (nScale >= 0) return false;
			nScale = 0;
			
			if (nOfst <= nStrt) nPos++;
			continue;
		}

		if ((chNew >= '0') && (chNew <= '9'))
		{	nValue = nValue * 10 + parseInt(chNew);
			nScale++;
			if (nOfst <= nStrt)
			{	if ((nPos != 0) || (chNew != '0')) nPos++;
			}
			continue;
		}

		if (chNew == '+')
		{	nSign = 1;
			continue;
		}

		if (chNew == '-') 
		{	nSign = -1;
			continue;
		}
		continue;	/* return false; */
	}

	if (((cNew >= 48) && (cNew <= 57)) || (cNew == 46)) nPos++;

	if (cNew == 43) nSign = 1;   // Plus sign forces positive

	if (nScale < 0) nScale = 0;
 
	if (!bImpliedDP)
	{	while (nScale < nReqScale)
		{	nValue *= 10;
			nScale++;
		}
		while (nScale > nReqScale)
		{	nDigit = nValue % 10;
			nValue = (nValue - nDigit) / 10;
			nScale--;
		}
	}

	sNew = '';

	for (nOfst = sFmt.length; nOfst > 0;)
	{	chFmt = sFmt.charAt(--nOfst);
		if ((nOfst == 0) && (chFmt == '\t')) break;
		
		if (chFmt == '-')
		{	if (nSign == -1)
			{	sNew = '-' + sNew;
			}
			else  
			{	sNew = ' ' + sNew;
			}
			continue;
		}

		if (chFmt == '+')
		{	if (nSign == -1)
			{ sNew = '-' + sNew;
			}
			else  
			{ sNew = '+' + sNew;
			}
			continue;
		}

		if (chFmt == ',')
		{	if (nValue != 0) sNew = chThousand + sNew;
			continue;
		}

		if (chFmt == '.')
		{	sNew = chDecimal + sNew;
			continue;
		}

		if (chFmt == '0')
		{	nDigit = nValue % 10;
			sNew = nDigit + sNew;
			nValue = (nValue - nDigit) / 10;
			continue;
		}

		if (chFmt == '#')
		{	if (nValue != 0) 
			{	nDigit = nValue % 10;
				sNew = nDigit + sNew;
				nValue = (nValue - nDigit ) / 10;
			} 
			continue;
		}
		sNew = chFmt + sNew;
	}

	if (nValue != 0) return false;

	if (bImpliedDP)
	{	nStrt = sNew.length;
	}
	else
	if ((nPos == 0) || (chNew == chDecimal))
	{	nStrt = sNew.indexOf(chDecimal);
		if (nStrt == -1)
			nStrt = sNew.length;
		else
		if (chNew == chDecimal) 
			nStrt++;
	}
	else
	{	var nDigit = 0;
		for (nStrt = 0; nStrt < sNew.length;nStrt++)
		{	chNew = sNew.charAt(nStrt);
			if ((chNew == chDecimal) || ((chNew >= '0') && (chNew <= '9')))
			{	nDigit++;
				if ((chNew == '0') && (nDigit == 1)) continue;
				if (nPos == 0) break;
				nPos--;
			}
		}
	}
	
	return iNmd_FmtPos(oRng, oFld, nStrt, sNew);
}

function iNmd_FmtPos(oRng, oFld, nStrt, sNew)
{	if (oRng)
	{	oRng.expand("textedit");
		oRng.text = sNew;
		oRng.moveEnd("character", 0 - sNew.length);
		oRng.moveStart("character", nStrt);
		oRng.select();
	}
	else
	{	oFld.value = sNew;
		oFld.selectionStart = nStrt;
		oFld.selectionEnd = nStrt;
	}
	return false; 
}
 
function iNmd_digapnd(cNew, sFmt, oFld, oRng)
{ var sStrip;
  var nOfst;
  var nOfsNew;
  var sFld = oFld.value;
  var sNew;
  var chFmt;
    
  sStrip = '';  
  for (nOfst = 0 ;nOfst < sFld.length; nOfst++)
  { chFmt = sFmt.charAt(nOfst);
    if ((chFmt == '0') || (chFmt == '#')) sStrip += sFld.charAt(nOfst);
  }
 
  if ((cNew == 8) || (cNew == 127))
  { sStrip = '0' + sStrip;
  }
  else
  { if ((cNew < 48) || (cNew > 57)) return false;
    sStrip = sStrip.substr(1) + String.fromCharCode(cNew);
  }

  sNew = '';

  nOfsNew = 0;

  for (nOfst = 0 ;nOfst < sFld.length; nOfst++)
  { chFmt = sFmt.charAt(nOfst);
    if ((chFmt == '0') || (chFmt == '#'))
      sNew += sStrip.charAt(nOfsNew++);
    else
      sNew += sFld.charAt(nOfst);
  }

  if (oRng)
  { oRng.expand("textedit");
    oRng.text = sNew;

    oRng.moveEnd("character", sNew.length);
    oRng.moveStart("character", sNew.length);
    oRng.select();
  }
  else
  { oFld.value = sNew;
  
    oFld.selectionStart = sNew.length;
    oFld.selectionEnd = sNew.length;
  }

  return false; 
}      
  
function iNmd_Valid()
{	if (!oFcs.in_rules) return true;
	
	var sRule = oFcs.in_rules;
	if (sRule == '') return true;

	var nValue;
	var bValue; 	// Input is numeric
	var sMin;
	var sMax;
	var nOfst;
	var sCur;

	bValue = iNmd_ToNum(oFcs.value, 1);
	nValue = nNumber;

	while (sRule != '')
	{	nOfst = sRule.indexOf(',');
		if (nOfst == -1)
		{	sCur = sRule;
			sRule = '';
		}
		else
		{	sCur = sRule.substring(0, nOfst);
			sRule = sRule.substring(nOfst + 1, sRule.length);
		}

		nOfst = sCur.indexOf('-', 1);
		if (nOfst == -1)
		{	sMin = sCur;
			sMax = sMin;
		}
		else
		{	sMin = sCur.substring(0, nOfst);
			sMax = sCur.substr(nOfst+1);
		}

		if (bValue == true)
		{	if (iNmd_ToNum(sMin, 0))
			{	if (nValue < nNumber) continue;
				if (iNmd_ToNum(sMax, 0))
				{	if (nValue <= nNumber) return true;
					continue;
				}
			}
		}

		if (sMin > oFcs.value) continue;
		if (sMax >= oFcs.value) return true;
	}
	
	bIgnoreFcs = 1;
	if (oFcs.focus) oFcs.focus();

	alert('"' + oFcs.value + '"' + sInvalid + oFcs.in_rules);

	bIgnoreFcs = 0;
	if (oFcs.focus) oFcs.focus();
			
	return false;
}

function iNmd_ToNum(sVal, bExternal)
{ var nOfst;
  var chVal;

  var chPoint;  
  var nSign = 0;
  var nScale = -1000;

  nNumber = 0;

  if (bExternal)
   chPoint = chDecimal;
  else
   chPoint = '.';

  for (nOfst = 0; nOfst < sVal.length;)
  { chVal = sVal.charAt(nOfst++);

    if (bExternal)
    { if (chVal == chCurrency) continue;
      if (chVal == chThousand) continue;
    }

    if (chVal == chPoint)
    { if (nScale >= 0) return false;
      nScale = 0;
      continue;
    }

    if ((chVal >= '0') && (chVal <= '9')) 
    { nNumber = (nNumber * 10) + parseInt(chVal,10);
      nScale++;
      continue;
    }

    if (nSign == 0)
    { if (chVal == '-') 
      { nSign = -1;
        continue;
      }

      if (chVal == '+')
      { nSign = 1;
        continue;
      }
    }
    return false;
  }
  
  while (nScale > 0)
  { nNumber /= 10;
    nScale--;
  }
  return true;
}
   
// Keydown events

function iNmd_kdn(e)
{	if (oFcs.readOnly) return true;

	cur_kc = (!iNmd_is_ie) ? e.which : e.keyCode ;

	if ((e.altKey) && (cur_kc >= 112) && (cur_kc <= 123))
	{	cur_kc -= 111;
		if (oCellEdit)
		{	iNmd_CellEdtEnd(240 + cur_kc, e);
		}
		else
		if (oChg)
		{	var sVal = iNmd_Val(oFcs);

			oFcs.in_oldval = sVal;
			AjxSend('C' + sFcsId + ',' + (128 + cur_kc) + sVal, 1);
		}
		
		AjxSend('K' + cur_kc,0);
		if (window.event) e.returnValue = false;
		return false;
	}		
		
	if (oCellEdit)
	{	if ((cur_kc == 9) || (cur_kc == 13) || (cur_kc == 27))
		{	iNmd_CellEdtEnd(cur_kc, e);
			return iNmd_NoKbd(e);
		}
		return true;
	}

	if (oFcs.in_auto)
	{	oFcs.in_autopend = true;
		setTimeout(iNmd_Auto,50);
		return true;
	}
	
	if ((cur_kc == 8) || (cur_kc == 46)) oChg = oFcs;

	if (cur_kc == 9)
	{	return iNmd_KdnChkTab(e);
	} 

	return true;
}

function iNmd_kdn_FMT(e)
{	if (oFcs.readOnly) return true;

	sFmt = oFcs.in_fmt;
	
	if (iNmd_kdn(e))
	{	if (cur_kc == 46)
		{ cur_kc = 127;
		}
		else
		if (cur_kc != 8) 
			return true;

		if (iNmd_fmtchr(e, cur_kc)) return true;
		if (window.event) e.returnValue = false;
	}
	return false;
}

// Keypress events

function iNmd_key(e)
{	var cNew = (!iNmd_is_ie) ? e.which : e.keyCode ;
 
	if (cur_kc == 13) 
	{	if (oFcs.type && (oFcs.type == 'textarea')) return true;
	
		if (iNmd_Valid())
		{	if (iNmd_is_ie) iNmd_IE_deselect();
		
			var sVal = iNmd_Val(oFcs);

			oChg = null;
			oFcs.in_oldval = sVal;
			
			AjxSend('C' + sFcsId + ',13' + sVal, 1);
		}
				
		if (window.event) e.returnValue = false;
		return false;
	}

	if ((cNew >= 32) && (cNew <= 127))
	{	oChg = oFcs;
	}

	return true;
}

function iNmd_key_FMT(e)
{	if (!iNmd_key(e)) return false;

	var cNew = (!iNmd_is_ie) ? e.which : e.keyCode ;

	if (cNew != 8)
	{	if (iNmd_fmtchr(e, cNew)) return true;
	}

	if (window.event) e.returnValue = false;
	return false;
}  

function iNmd_Menu(e, nCtl)
{	if (window.event) e = window.event;

	iNmd_MseXY(e);

	if (oChg != null)
	{	iNmd_Chg(oChg);
	}

	AjxSend('C' + nCtl + ',0', 0);

	if (window.event) e.returnValue = false;
	return false;
}
	
function iNmd_Spin(nCtl, e)
{	if (window.event) e = window.event;
	var oSpin =  e.target ? e.target : e.srcElement;
	
	if (oSpin && !oSpin.disabled)
	{	var oObj = i_Id(oSpin.getAttribute('iML'));
		if (oObj && !oObj.disabled)
		{	if (iNmd_is_ie) oSpin.ondblclick = Function('iNmd_Spin(' + nCtl + ',event);');
			
			if (oObj != oFcs) iNmd_focus(oObj);
			oObj.focus();
			
			AjxSend('S' + nCtl + ',' + oSpin.className.substr(5));
		}

	}
	return e.returnValue = false;
}
	
function iNmd_BtnDClk()
{ var e = window.event;
  var oBtn =  e.target ? e.target : e.srcElement;
  var sId = oBtn.id.substr(3);

  if (window.event) e.returnValue = false;    
  if (AjxSend('C' + sId + ',2', 1)) return false;
  iNmd_Submit(sId);
  return false;
}

function iNmd_BtnFcs(e)
{	var oBtn;
	if (window.event) e = window.event;
	if (e)
		oBtn =  e.target ? e.target : e.srcElement;
	else
	if (iNmd_BtnClk.arguments.length == 2) 
		oBtn = iNmd_BtnClk.arguments[1];
	else
		return false;

	oBtn.onkeydown = iNmd_KdnChkTab;
	oBtn.onkeypress = iBtnKey;

	if (!oBtn.in_signalonly) iNmd_focus(oBtn);
}

function iBtnKey(e)
{	if (window.event) e = window.event;
	var chKey = (!iNmd_is_ie) ? e.which : e.keyCode ;
	
	if (chKey == 13) 
	{	var oBtn =  e.target ? e.target : e.srcElement;
		if (!oBtn.id) oBtn = oBtn.parentNode;
		
		AjxSend('C' + oBtn.id.substr(3) + ',0', 0);
		return e.returnValue = false;
	}
	return true;
}

function iNmd_BtnClk(e)
{	var oBtn;
	
	if (window.event) e = window.event;
	if (e)
		oBtn =  e.target ? e.target : e.srcElement;
	else
	if (iNmd_BtnClk.arguments.length == 2) 
		oBtn = iNmd_BtnClk.arguments[1];
	else
		return false;
		
	if (!oBtn.id) oBtn = oBtn.parentNode;
	if (window.event) e.returnValue = false;    

	if (oBtn.disabled) return false;
	if (oBtn.className == 'iButtonDis') return false;

	if (e) iNmd_MseXY(e);

	if (oBtn.in_signalonly)
	{	if (oChg) iNmd_Chg(oChg, 'U');
	}
	else
	{	if (oFcs != oBtn) iNmd_focus(oBtn);
		if (oBtn.focus)
		{	try { oBtn.focus(); } catch(err) { }
		}
	}

	var sId = oBtn.id.substr(3);

	if (iNmd_is_ie) oBtn.ondblclick = iNmd_BtnDClk; 

	if (AjxSend('C' + sId + ',1', 0))
	{	if (oFcs && oFcs.focus)
		{	try { oFcs.focus(); }
			catch(err) { } 
		}
	}
	else
	{	iNmd_Submit(sId);
	}
	return false;
}

/* Check box */

function iNmd_CbxFcs(oCbx)
{	oCbx.onkeydown = iNmd_KdnChkTab;
	
	oCbx.onclick = iNmd_CbxEvt;
	oCbx.onkeypress = iNmd_CbxEvt;

	if (oFcs != oCbx) iNmd_focus(oCbx);

	return true;
}

function iNmd_CbxEvt(e)
{	if (window.event) e = window.event;
	var oCbx = e.target ? e.target : e.srcElement;

	if (oCbx.disabled) return e.returnValue = false;

	if (oCbx.focus) oCbx.focus();

	if (e.type == 'keypress')
	{	var cKey = iKey(e);
	
		if (cKey != 13) return true;
		AjxSend('C,13');
	
		return e.returnValue = false;
	}	
	
	var oVal;
	var sVal;

	oVal = i_Id('v' + oCbx.id);
	sVal = oVal.value;

	if (sVal == '0')
	{	sVal = '1';
	}
	else
	if (sVal == '2')
	{	sVal = '0';
	}
	else
	if (oVal.in_type == '3') 
	{	sVal = '2';
	}
	else
	{	sVal = '0';
	}

	iNmd_CbxChg(oCbx, sVal, oVal);
	AjxSend('C' + oCbx.id.substr(3) + ',1:' + sVal, 0);
	
	if (oCbx.type && (oCbx.type == 'checkbox')) return true;
	return iNmd_NoKbd(e);
}

function iNmd_CbxSet(idCbx, sVal)
{	var oVal;
	var oCbx;

	oCbx = i_Id(idCbx);
	oVal = i_Id('v' + idCbx);

	if (!oVal) { alert("Cannot find: v" + idCbx); return; }

	iNmd_CbxChg(oCbx, sVal, oVal);
}

function iNmd_CbxChg(oCbx, sVal, oVal)
{	oVal.value = sVal;

	if (oVal.in_h0)
	{	if (sVal == '0')
			oCbx.innerHTML = oVal.in_h0;
		else
		if (sVal == '1')
			oCbx.innerHTML = oVal.in_h1;
		else
			oCbx.innerHTML = oVal.in_h2;
	}
	else
	{	if (sVal == '0')
		{	oCbx.checked = false;
			oCbx.className = 'iCheck_box'; 
		}
		else
		{	oCbx.checked = true;
			if (sVal == '2')
				oCbx.className = 'iCheck_box_3rd';
			else
				oCbx.className = 'iCheck_box'; 
		}
	}
	return;
}

/* List/Drop box */

function iNmd_LbxFcs(oLbx)
{	oLbx.onkeydown = iNmd_KdnChkTab;
	oLbx.onkeypress = iNmd_LbxEvt;
//	oLbx.onclick = iNmd_LbxEvt;
	oLbx.onmouseup = iNmd_LbxEvt;

	if (oFcs == oLbx) return true;

	if (bFireFox) var sOld = oLbx.in_oldval;
	
	iNmd_focus(oLbx);

	if (bFireFox) 
	{	oLbx.in_oldval = sOld;
		
		if (oLbx.in_auto)
		{	oLbx.in_autopend = true;
			setTimeout(iNmd_Auto,50);
		}
	}
}

function iNmd_LbxEvt(e)
{	if (window.event) e = window.event;
	var oLbx = (e.target ? e.target : e.srcElement);
	if (!oLbx.id) oLbx = oLbx.parentNode;
	
	if (oLbx != oFcs) return e.returnValue = false;
	var bSts = true;
		
	if (e.type == 'keypress')
	{	var cKey = iKey(e);
		if (cKey == 13)
		{	var sVal = iNmd_Val(oLbx);
			oChg = null;
			oLbx.in_oldval = sVal;

			AjxSend('C' + oLbx.id.substr(3) + ',13' + sVal,0);
			bSts = false;
		}
		else
		if (cKey == 9)
		{	return e.returnValue = false;
		}	
	}

	if (oLbx.in_auto)
	{	oLbx.in_autopend = true;
		setTimeout(iNmd_Auto,50);
	}
	else
	if ((e.type == 'mouseup') && (oLbx.value))
	{	if (oLbx.in_dbltmr)
		{	var sVal = iNmd_Val(oLbx);
			oChg = null;
			oLbx.in_oldval = sVal;
			AjxSend('C' + oLbx.id.substr(3) + ',2' + sVal,0);
			oLbx.in_dbltmr = false;
		}
		else
		{	oLbx.in_dbltmr = true;
			setTimeout(function () { oLbx.in_dbltmr = false; }, 500);
		}
	}
					
	return e.returnValue = bSts;
}
  
function iNmd_LbxClr(idLbx)
{	var oLbx = i_Id(idLbx);
	if (!oLbx) { alert("Cant find:" + idLbx); return; }
	oLbx.length = 0;
}

function iNmd_LbxUpd(idLbx, nIdx, sVal)
{	var oLbx = i_Id(idLbx);
	if (!oLbx) { alert("Cant find:" + idLbx); return; }
  
	if (oLbx.type == 'text') oLbx = i_Id('vdl_' + idLbx.substr(3));
	oLbx.options[nIdx-1].text = sVal;
}

function iNmd_LbxDel(idLbx, nIdx)
{	var oLbx = i_Id(idLbx);
	if (!oLbx) { alert("Cant find:" + idLbx); return; }
	if (oLbx.type == 'text') oLbx = i_Id('vdl_' + idLbx.substr(3));

	oLbx.remove(nIdx-1);

	while (nIdx < oLbx.length)
	{	oLbx.options[nIdx].value = (nIdx + 1).toString(10);
		nIdx++;
	}

	oLbx.in_oldval = iNmd_Val(oLbx);
}

function iNmd_LbxAdd(idLbx, nIdx, sVal)
{	var oLbx = i_Id(idLbx);
	var oOpt;
	var sIdx;

	if (!oLbx) { alert("Cant find:" + idLbx); return; }

	if (oLbx.type == 'text') oLbx = i_Id('vdl_' + idLbx.substr(3));

	if (nIdx > oLbx.length) { alert("Index invalid:" + idLbx + "," + nIdx); return; }

	if (nIdx == 0) 
		sIdx = (oLbx.length + 1).toString(10);
	else
		sIdx = nIdx.toString(10);
	    
	oOpt = new Option(sVal, sIdx);

	if (iNmd_is_ie)
	{	if (nIdx == 0)
			oLbx.add(oOpt);
		else
			oLbx.add(oOpt, nIdx-1);
	}
	else
	{	if (nIdx == 0)
			oLbx.add(oOpt, null);
		else
			oLbx.add(oOpt, oLbx.options[nIdx-1]);
	}

	while (nIdx < oLbx.length)
	{	oLbx.options[nIdx].value = (nIdx + 1).toString(10);
		nIdx++
	}

	oLbx.in_oldval = iNmd_Val(oLbx);
	return;
}

function iNmd_LbxSel(idLbx, sOpts)
{	var oLbx = i_Id(idLbx);
	var nStrt;
	var nFini;
	var nSel;
	var nOfs;

	if (!oLbx) { alert("Cant find:" + idLbx); return; }

	nStrt = 0;
	nIdx = 0;
	
	oLbx.selectedIndex = -1;

	while (1)
	{	nFini = sOpts.indexOf(',', nStrt);
		if (nFini == -1) break; 
	    
		nSel = parseInt(sOpts.substring(nStrt, nFini),10) - 1;
		if (nSel > oLbx.length) break;

		if (!oLbx.multiple)
		{	oLbx.selectedIndex = nSel;
			break;
		}

		while (nIdx < nSel)
		{	oLbx.options[nIdx++].selected = false;
		}

		oLbx.options[nIdx++].selected = true;
		nStrt = nFini + 1;
	}
	
	oLbx.in_oldval = iNmd_Val(oLbx);
	return;
}
  
function iNmd_LbxLoad(idLbx)
{ 	var oLbx = i_Id(idLbx);
	var oOpt;
	var sIdx;

	if (!oLbx) { alert("Cant find:" + idLbx); return; }

	if (oLbx.type == 'text') oLbx = i_Id('vdl_' + idLbx.substr(3));

	oLbx.length = 0;
	oLbx.selectedIndex = -1;
  
	for (var i = 1; i< iNmd_LbxLoad.arguments.length; i++)
	{	oOpt = new Option(iNmd_LbxLoad.arguments[i], i.toString(10));
		if (iNmd_is_ie)
			oLbx.add(oOpt);
		else
			oLbx.add(oOpt, null);
	} 
	
	oLbx.in_oldval = iNmd_Val(oLbx);
}

function iNmd_LbxChg(e)
{	if (window.event) e = window.event;
	var oLbx = (e.target ? e.target : e.srcElement);
	
	if (oLbx.in_auto || (!oLbx.size))
	{	oLbx.in_autopend = true;
		setTimeout(iNmd_Auto,50);
	}
	else
		oChg = oLbx;
		
	return true;
}

/* Radio Buttons */

function iNmd_RbtFcs(oBtn)
{	if (oFcs == oBtn) return true;
	iNmd_focus(oBtn);
	
	oBtn.onkeydown = iNmd_RbtEvt;
	oBtn.onkeypress = iNmd_RbtEvt;
	return true;
}

function iNmd_RbtEvt(e)
{	if (window.event) e = window.event;
	var oBtn = e.target ? e.target : e.srcElement;
	if (oBtn.disabled) return e.returnValue = false;
	
	if (oFcs != oBtn) iNmd_RbtFcs(oBtn);
	if (oBtn.focus) oBtn.focus();

	if (e.type == 'keydown') 
	{	return iNmd_RbtKdn(oBtn,e);
	}
	
	if (e.type == 'keypress')
	{	var cKey = iKey(e);
	
		if (cKey != 13) return true;
		AjxSend('C,13');
	
		return e.returnValue = false;
	}	
	
	var sId;
	var sVal;
	var nOfsScore;

	sId = oBtn.id.substr(3);
	nOfsScore = sId.indexOf('_',0);

	sVal = sId.substr(nOfsScore + 1);
	sId = sId.substring(0, nOfsScore);

	iNmd_RbtSet(sId, sVal);
	AjxSend('C' + sId + ',1:' + sVal, 0);

	if (bSafari)
	{	if (e.stopPropagation) e.stopPropagation();
		if (e.preventDefault) e.preventDefault();
		return e.returnValue = false;
	}
}

function iNmd_RbtKdn(oBtn, e)
{	var	cKey = iKey(e);
	var nDir;
	
	if ((cKey == 37) || (cKey == 38))
		nDir = -1;
	else
	if ((cKey == 39) || (cKey == 40))
		nDir = 1;
	else
		return 	iNmd_KdnChkTab(e);

	var nOfs = oBtn.id.indexOf('_', 4);
	if (nOfs < 0) return true;

	sId = oBtn.id.substr(0,nOfs+1);	
	nOfs = parseInt(oBtn.id.substr(nOfs+1,10));

	while (1)
	{	nOfs += nDir;
		oBtn = i_Id(sId + nOfs);
		if (!oBtn) break;
		if (!oBtn.disabled)
		{	if (oBtn.focus) oBtn.focus();
			break;
		}
	}
	return e.returnValue = false;		
}
	
function iNmd_RbtSet(sId, sVal)
{ var oBtn;
  var oRbt;
  
  oRbt = i_Id('id_' + sId);
  if (!oRbt) { alert('Cant find id_'+sId); return; }
  
  if (oRbt.value != '')
  { oBtn = i_Id('rb_' + sId + '_' + oRbt.value);
    if (!oBtn) { alert('Cant find rb_' + sId + '_' + oRbt.value); return; }
    if (oBtn.in_h0)
	{ oBtn.innerHTML = oBtn.in_h0;
	  oBtn.className = 'iRadio_btn';
	}
	else
	{ oBtn.checked = false;
	}
  }
  
  if (sVal == 0) sVal = "";
  oRbt.value = sVal;
  
  if (sVal == "") return;
  
  oBtn = i_Id('rb_' + sId + '_' + sVal);
  if (!oBtn) { alert('Cant find rb_' + sId + '_' + sVal); return; }
 
  if (oBtn.in_h1)
  { oBtn.innerHTML = oBtn.in_h1;
    oBtn.className = 'iRadio_btn_down';
  }
  else
  {  oBtn.checked = true;
  }
  
}

function iNmd_RbtVal(oBtn)
{ var sId;
 
  sId = oBtn.id.substr(3);
  sId = 'id_' + sId.substring(0, sId.indexOf('_',0));
  
  return i_Id(sId);
}
 
/* Variable DROP box (Emulated) */

function iNmd_VdbShow(oImg)
{	var sId = oImg.id.substr(3);
	var oList = i_Id('vdl_' + sId);

	if (!oList) { alert('Unable to find: vdl_' + sId); return false; }

	var oDbx = i_Id('id_' + sId);
	if (oDbx.disabled) return false;

	if (oList.style.display != 'block')
	{	var x, y, wd;
		var oText = i_Id('spn_' + sId);
		
		iNmd_focus(oDbx);
		
		x = iNmd_Left(oText);
		y = iNmd_Top(oText) + oText.offsetHeight;
		wd = oText.offsetWidth;
		
		oList.style.top = y + 'px';
		oList.style.left = x + 'px' ;
		
		if (oList.offsetWidth < wd) oList.style.width = wd + 'px';
			
		oList.style.display = 'block';
		
		oList.onblur = iNmd_VdbEvt;
		oList.onchange = iNmd_VdbEvt;
		oList.onkeypress = iNmd_VdbEvt;
		oList.onclick = iNmd_VdbEvt;

		oList.tabIndex = oDbx.tabIndex;
		oDbx.tabIndex = 0;

		oList.focus();
	}
	else
	{	oList.style.display = 'none';
		oDbx.tabIndex = oList.tabIndex;
		oList.tabIndex = 0;
		oDbx.focus();
	}
	
	return false;
}

function iNmd_VdbEvt(e)
{	if (window.event) e = window.event;
	var oList = (e.target ? e.target : e.srcElement); 
	if (oList.style.display == 'none') return;
	
	if (e.type == 'keypress')
	{	var cKey = (!iNmd_is_ie) ? e.which : e.keyCode;
		if (cKey == 9) document.inomads._eom.value = '\t';
		if (cKey != 13) return true;
		
		document.inomads._eom.value = '\r'; 
	}
	
	if (e.type == 'click')
		document.inomads._eom.value = '\x01';

	var sId = oList.id.substr(4);
	var oDbx = i_Id('id_' + sId);
	
	if (oList.selectedIndex >= 0)
	{	oDbx.value = oList.options[oList.selectedIndex].text;
	
		if (e.type == 'change')
		{	if (oDbx.in_auto)
			{	oDbx.in_autopend = true;
				setTimeout(iNmd_Auto,50);
			}
			return true;
		}
	}
	else
	{	if (e.type == 'change') return true;
	}
	
	oDbx.tabIndex = oList.tabIndex;
	oList.tabIndex = 0;
	
	oList.style.display = 'none';

	iNmd_Chg(oDbx);
	
	if (document.inomads._eom.value != '\t') oDbx.focus();

	if ((document.selection) && (!bOpera))
	{	var oRng = document.selection.createRange();
		{	if (oRng)
			{	oRng.moveStart("character", -100000);
				oRng.moveEnd("character", 100000);
				oRng.select();
			}
		}
	}
	else
	if ('selectionStart' in oDbx)
	{	oDbx.selectionStart = 0;
		oDbx.selectionEnd = oDbx.value.length;
	}

	if (e.type == 'keypress')
		return e.returnValue = false;
		
	return true;
}

function iNmd_VdbKdn(e)
{ var cur_kc = (!iNmd_is_ie) ? e.which : e.keyCode ;

  if (cur_kc == 40)
  { iNmd_VdbShow(oFcs);

    if (window.event) e.returnValue = false;
    return false;
  }
  
  return iNmd_kdn(e);
}

/* List view specifics */

function iNmd_LvuFcs(oLbx)
{	iNmd_focus(oLbx);
	
	oLbx.in_blur = iNmd_LvuBlr;
	oLbx.onkeydown = iNmd_LvuKdn;	
	oLbx.onkeypress = iNmd_LvuKey;
	iNmd_LvuRowFcs(oLbx, null);

	return true;
}

function iNmd_LvuRowFcs(oLbx, oRow)
{	iNmd_LvuBlr(oLbx);

	if (!oRow)
	{	if (!oLbx.in_fcsId) oLbx.in_fcsId = '1';
		oRow = i_Id('lr_' + oLbx.id.substr(3) + '_' + oLbx.in_fcsId);
		if (!oRow) return;
	}

	if (oRow.className == 'iListSel')
		oRow.className = 'iListSelFcs';
	else
	if (oRow.className == 'iListRow')
		oRow.className = 'iListRowFcs';

	oLbx.in_fcsId = oLbx.in_fcsNo = oRow.id.substr(9);
}

function iNmd_LvuBlr(oLbx)
{	if (!oLbx.in_fcsNo) return;

	var oCur = i_Id('lr_' + oLbx.id.substr(3) + '_' + oLbx.in_fcsNo);

	if (oCur)
	{	if (oCur.className == 'iListSelFcs')
			oCur.className = 'iListSel';
		else
		if (oCur.className == 'iListRowFcs')
			oCur.className = 'iListRow';
	}
	
	oLbx.in_fcsNo = null;
}

function iNmd_LvuKey(e)
{	if (window.event) e = window.event;
	if (iKey(e) != 13) return true;
	
	var oLbx = e.target ? e.target : e.srcElement;

	var sVal = iNmd_Val(oFcs);
	oChg = null;

	oFcs.in_oldval = sVal;
	if (oFcs.in_fcsId) sVal += '#' + oFcs.in_fcsId;

	AjxSend('C' + sFcsId + ',13' + sVal, 1);
		
/* Ultimately send to host to search */	

	return e.returnValue = false;
}

function iNmd_LvuKdn(e)
{	if (window.event) e = window.event;
	var oLbx = e.target ? e.target : e.srcElement;
	
	var cKey = iKey(e);
	if (cKey == 9) return iNmd_KdnChkTab(e);
	if (cKey == 13) return true;
	
	var cFcs = 0;
	if (oLbx.in_fcsId) cFcs = parseInt(oLbx.in_fcsId,10);
	
	var nFcs = cFcs;
	var nLast = oLbx.in_top + oLbx.in_cnt - 1;

	switch (cKey)
	{	case 33:	/* PgUp */
			if (oLbx.in_top == nFcs)
				nFcs -= oLbx.in_cnt;
			else
				nFcs = oLbx.in_top;
			break;
		case 34:	/* PgDn */
			if (nFcs >= nLast)
				nFcs = nLast + oLbx.in_cnt;
			else
				nFcs = nLast;
			break;
			
		case 35:	/* End */
			nFcs = oLbx.in_tot;
			break;
		case 36:	/* Home */
			nFcs = 1;
			break;
		
		case 38:	/* Up */
			nFcs--;
			break;
		case 40:	/* Down */
			if (oLbx.value == '')
				cFcs--;
			else
				nFcs++;
			break;
			
		default:
			return iNmd_CmnKdn(e);
	}

	e.returnValue = false;
	if (e.stopPropagation) e.stopPropagation();
	if (e.preventDefault) e.preventDefault();
	e.cancelBubble = true;
    e.cancel = true;
		 
	if (nFcs > oLbx.in_tot) nFcs = oLbx.in_tot;
	if (nFcs < 1) nFcs = 1;
	if (nFcs == cFcs) return false;

	var sVal;
	var sNo = nFcs;
	oLbx.in_fcsId = sNo;
	
	if (oLbx.in_multi && e.shiftKey)
	{	while (1)
		{	sVal = oLbx.value;
			if (cFcs != 0)
			{	sNo = cFcs;

				iNmd_LvuOn(oLbx, sNo);
				if (oLbx.value == sVal) iNmd_LvuOff(oLbx, sNo);
			}	
			if (cFcs < nFcs)
				cFcs++;
			else
			if (cFcs > nFcs)
				cFcs--;
			else
				break;
		}
	}
	else
	{	iNmd_LvuSelInt(oLbx, sNo + ',');
	}
	
	if (oLbx.in_auto)
	{	AjxSend('C' + sFcsId + ',0:' + oLbx.value + '#' + sNo, 1);
	}
	else
	{	oChg = oLbx;
	}
	
	if (nFcs < oLbx.in_top)
	{	AjxSend('S' + sFcsId + ',Top:' + nFcs + ',' + nFcs, 1);
	}
	else
	if (nFcs > nLast)
	{	AjxSend('S' + sFcsId + ',Top:' + Math.max(1,nFcs - oLbx.in_cnt + 1) + ',' + nFcs, 1);
	}
	else
	{	oLbx.in_fcsId = sNo;
		iNmd_LvuRowFcs(oLbx, null);
	}
	return false;
}

function iNmd_LvuHdrClk(sId, nCol)
{	if (bResize) return;
	AjxSend('S' + sId + ',Srt:' + nCol,0);
}

function iNmd_LvuClk(oRow, e)
{	var sId;
	var sVal;
	var nOfsScore;
	var bDbl;

	sId = oRow.id.substr(3);
	nOfsScore = sId.indexOf('_',0);

	sVal = sId.substr(nOfsScore + 1);
	sId = sId.substring(0, nOfsScore);

	var oLbx = i_Id('id_' + sId);
	if (!oLbx) { alert('Cannot find id_' + sId); return false; }

	if (oFcs != oLbx) iNmd_LvuFcs(oLbx);
	if (!bIphone) oLbx.focus();

	if (window.event) e = window.event; 

	if (oRow.id.substr(0,3) != 'tx_')
	{	if ((oLbx.in_multi) && (e.ctrlKey || e.shiftKey))
		{	if (oRow.className.substr(0,8) == 'iListSel')
			{	iNmd_LvuOff(oLbx, sVal);
			}
			else
			{	iNmd_LvuOn(oLbx, sVal);
			}
		}
		else
		{	iNmd_LvuSelInt(oLbx, sVal + ',');
		}

		iNmd_LvuRowFcs(oLbx, oRow);
	}
	else
	{	oLbx.value = sVal;
		oLbx.in_auto = true;
	}
	
	bDbl = false;

	if (iNmd_is_ie)
	{	oRow.ondblclick = Function('return iNmd_LvuClk(this, event);');
		if (e.type == 'dblclick') bDbl = true;
	}
	else
	{	bDbl = i_DblClk(oRow);
	}

	sVal = oLbx.value;
	if (oLbx.in_fcsId) sVal += '#' + oLbx.in_fcsId;
	
	oLbx.in_oldval = null;
	oChg = null;
	
	if (!bDbl)
	{	if (oLbx.in_auto)
		{	AjxSend('C' + sId + ',1:' + sVal, 0);
		}
		else
		{	document.inomads._eom.value = '\x01';
			oChg = oLbx;
		}
	}
	else
	{	AjxSend('C' + sId + ',2:' + sVal, 0);
	}

	if (e.stopPropagation) e.stopPropagation();
	if (e.preventDefault) e.preventDefault();
	e.cancelBubble = true;
	e.cancel = true;
	e.returnValue = false;
	
	return false;
}

function iNmd_LvuOff(oLbx, sVal)
{	var sTxt = ',' + oLbx.value;
	var sTxt2 = sTxt.replace(',' + sVal + ',',',')

	if (sTxt != sTxt2) oLbx.value = sTxt2.substr(1);

	var oRow = i_Id('lr_' + oLbx.id.substr(3) + '_' + sVal);
	if (oRow) 
	{	if ((oFcs == oLbx) && oLbx.in_fcsId && (oLbx.in_fcsId == sVal))
			oRow.className = 'iListRowFcs';
		else
			oRow.className = 'iListRow';
	}
}

function iNmd_LvuOn(oLbx, sVal)
{	var sTxt = ',' + oLbx.value;
	var sTxt2 = sTxt.replace(',' + sVal + ',',',')

	if (sTxt.indexOf(',' + sVal + ',') < 0) oLbx.value += sVal + ',';
  
	var oRow = i_Id('lr_' + oLbx.id.substr(3) + '_' + sVal);
	if (oRow)
	{	if ((oFcs == oLbx) && oLbx.in_fcsId && (oLbx.in_fcsId == sVal))
			oRow.className = 'iListSelFcs';
		else
			oRow.className = 'iListSel';
	}
}

function iNmd_LvuIsOn(oLbx, sVal)
{	var sTxt = ',' + oLbx.value;
	if (sTxt.indexOf(',' + sVal + ',') < 0)
		return false;
	else
		return true;
}
	
function iNmd_LvuSel(sId, sOpts, nPos, nTot, nVScr)
{	var oLbx = i_Id(sId);
	if (!oLbx) return;
	
	iNmd_CmnScr(sId.substr(3), nVScr);
	
	oLbx.in_tot = nTot; /* Item count */
	
	if (nPos == 0) 
		oLbx.in_fcsId = '1';
	else	
		oLbx.in_fcsId = nPos.toString(10);

	if (oLbx == oChg) sOpts = oLbx.value;

	iNmd_LvuLines(oLbx);	/* Set top & Number */

	iNmd_LvuSelInt(oLbx, sOpts);
	if (oFcs == oLbx) iNmd_LvuRowFcs(oLbx, null);
}

function iNmd_LvuSelInt(oLbx, sOpts)
{	var nOfs;
	var sVal;
	var nStrt = 0;
	var nIdx = 0;
	var nFini;

	while (1)
	{	nOfs = oLbx.value.indexOf(',');
		if (nOfs <= 0) break;
		sVal = oLbx.value.substr(0,nOfs);
		iNmd_LvuOff(oLbx, sVal);
	}
	
	while (1)
	{	nFini = sOpts.indexOf(',', nStrt);
		if (nFini == -1) break; 
		    
		sVal = sOpts.substring(nStrt, nFini);
		iNmd_LvuOn(oLbx, sVal);

		nStrt = nFini + 1;
	}
	return;
}  

function iNmd_LvuLines(oLbx)
{	oLbx.in_top = 1;
	oLbx.in_cnt = 1;
	
	var oDiv = i_Id('dv_' + oLbx.id.substr(3));
	if (!oDiv) return;
	
	var oTbl = i_Id('tb_' + oLbx.id.substr(3));
	if (oTbl)
	{	var oRow;
		var nRowNo;
		var nDivBtm = iNmd_Top(oDiv) + oDiv.offsetHeight + 3;
		
		oLbx.in_top = 0;
		oLbx.in_cnt = 0;
		
		for (var nRow = oTbl.rows.length; nRow > 0;)
		{	oRow = oTbl.rows[--nRow];
			
			if (!oRow.id) continue;
			if (oRow.id.substr(0,2) != 'lr') continue;
			
			if (oLbx.in_cnt == 0)
			{	if ((iNmd_Top(oRow) + oRow.offsetHeight) > nDivBtm) continue;
			}
			
			oLbx.in_cnt++;
			oLbx.in_top = parseInt(oRow.id.substr(9),10);
		}
	}
	return;
}

/* Tree view functions */

function iNmd_TvuImg(e)
{	var oImg = e.target ? e.target : e.srcElement;
	var oRow = i_Id('tx_' + oImg.id.substr(3));
	
	if (oRow)
	{	if (iNmd_is_ie)
		{	if (!oImg.ondblclick)
				oImg.ondblclick = Function('return iNmd_TvuImg(event);');
		}
		return iNmd_TvuClk(oRow, e);
	}

	e.returnValue = false;
	return false;
}

function iNmd_TvuClk(oRow, e)
{	var sId;
	var sVal;
	var nOfsScore;
	var bDbl;
	
	sId = oRow.id.substr(3);
	nOfsScore = sId.indexOf('_',0);

	sVal = sId.substr(nOfsScore + 1);
	sId = sId.substring(0, nOfsScore);

	var oLbx = i_Id('id_' + sId);
	if (!oLbx) { alert('Cannot find id_' + sId); return false; }

	if (oFcs != oLbx)
	{	if (!oLbx.tv_sel) oLbx.tv_sel = oRow;
		iNmd_focus(oLbx);
	}
	
	if (!bIphone) oLbx.focus();
		
	oLbx.value = sVal;
	bDbl = false;

	if (iNmd_is_ie)
	{	if (!oRow.ondblclick) oRow.ondblclick = Function('return iNmd_TvuClk(this, event);');
		if ((e) && (e.type != 'click')) bDbl = true;
	}
	else
	{	bDbl = i_DblClk(oRow);
	}

	if (e == null)
	{	AjxSend('S' + sId + ',Sel:' + sVal, 0);
		oLbx.in_chg = true;
		return;
	}

	var sSig;
	
	if (bDbl)
	{	sSig = 'Dbl';	
		oLbx.in_chg = false;
	}
	else
	{	oLbx.in_chg = true;
		var oEvt = e.target ? e.target : e.srcElement;
		if (oEvt && oEvt.id && (oEvt.id.substr(0,2) == 'ts'))
		{	sSig = 'Ste';
		}
		else
		{	sSig = 'Clk';
		}
	}
	
	AjxSend('S' + sId + ',' + sSig + ':' + sVal, 0);
	return;
/*		
	if (e.stopPropagation) e.stopPropagation();
	if (e.preventDefault) e.preventDefault();
	e.cancelBubble = true;
	e.cancel = true;
	e.returnValue = false;

	return false;
*/	
}

function iNmd_TvuSel(sId, nId)
{	var oLbx = i_Id('id_' + sId);
	var oItem = null;
	
	if (nId) oItem = i_Id('tx_' + sId + '_' + nId);
	
	if (oLbx.tv_sel)
	{	oLbx.tv_sel.className = 'iTvText';
		oLbx.tv_sel = null;
	}
	
	if (oItem)
	{	oLbx.tv_sel = oItem;
		oItem.className = 'iTvTextSel';
	}
	
	oLbx.value = nId;
	
	if (oFcs == oLbx) iNmd_TvuFcs(oLbx);
	
	if (!oItem) return;
	
	var oDiv = i_Id('dv_' + sId);
	if (!oDiv) return;
/* Logic removed -- don't scroll tree to selected item 
	var nDivTop = iNmd_Top(oDiv); 
	var nItemTop = iNmd_Top(oItem) + 1 - nDivTop - oDiv.scrollTop;
	var nItemBtm = nItemTop + oItem.offsetHeight;

	if (nItemTop < 0) 
		oDiv.scrollTop += nItemTop;
	else
	if (nItemBtm > oDiv.clientHeight)
		oDiv.scrollTop += (nItemBtm - oDiv.clientHeight);
			
	var nDivLeft = iNmd_Left(oDiv);
	var nItemLeft = iNmd_Left(oItem) - nDivLeft;
	if (nItemLeft < 0) nItemLeft = 0;

	if ((nItemLeft-16) < oDiv.scrollLeft) 
	{	oDiv.scrollLeft = Math.max(0, nItemLeft-16);
	}
	else
	{	if ((oDiv.scrollLeft + oDiv.clientWidth) < (nItemLeft + oItem.offsetWidth))
		{	oDiv.scrollLeft = Math.max(0,nItemLeft + oItem.offsetWidth - oDiv.clientWidth);
		}
	}
*/
	return;
}

function iNmd_TvuFcs(oLbx)
{	if (!oLbx.tv_sel)
	{	var oItem = i_Id('tx_' + oLbx.id.substr(3) + '_1');
		if (oItem)
		{	iNmd_TvuClk(oItem, null);
			oLbx.in_chg = null;
		}
	}
	
	if (oLbx.tv_sel)	
	{	if (oLbx.tv_sel.className == 'iTvText')
			oLbx.tv_sel.className = 'iTvTextFcs';
		else
		if (oLbx.tv_sel.className == 'iTvTextSel')
			oLbx.tv_sel.className = 'iTvTextSelFcs';
	}

	iNmd_focus(oLbx);
	oLbx.in_blur = iNmd_TvuBlr;
}

function iNmd_TvuBlr(oLbx)
{	if (oLbx.tv_sel)	
	{	if (oLbx.tv_sel.className == 'iTvTextFcs')
			oLbx.tv_sel.className = 'iTvText';
		else
		if (oLbx.tv_sel.className == 'iTvTextSelFcs')
			oLbx.tv_sel.className = 'iTvTextSel';
	}
	
	if ((oLbx.in_chg) && (!oLbx.in_auto))
	{	document.inomads._eom.value = '\x01';
		oChg = oLbx;
		oLbx.in_chg = false;
	}
}

function iNmd_TvuKdn(e)
{	var nKey = (e.which) ? e.which : e.keyCode ;
	if (nKey == 9) 
	{	iNmd_TvuBlr(oFcs);
		return iNmd_KdnChkTab(e);
	}

	var sKey;
	var oItem = oFcs.tv_sel;
	var	bFirst = false;
	var nScroll;
	
	if ((oItem == null) || (oItem.className == 'iTvTextFcs'))
	{	oItem = i_Id('tx_' + sFcsId + '_1');
		bFirst = true;
	}
	
	switch (nKey)
	{	case 33: 	/* PgUp */
			oItem = iNmd_TvuPgup(oItem);
			if (oItem) iNmd_TvuClk(oItem, null);
	
			break;
		case 34: 	/* PgDn */
			oItem = iNmd_TvuPgdn(oItem);
			if (oItem) iNmd_TvuClk(oItem, null);
	
			break;
			
		case 35: 	/* End */
			var oItem2 = oItem;
			while(oItem2) 
			{	oItem = oItem2;
				oItem2 = iNmd_TvuNxt(oItem);
			}
			if (oItem) iNmd_TvuClk(oItem, null);
			break;
			
		case 36:	/* Home */
			if (!bFirst) oItem = i_Id('tx_' + sFcsId + '_1');
			if (oItem) iNmd_TvuClk(oItem, null);
			break;
			
		case 37: 	/* Left */
			iNmd_Signal(sFcsId, "Col:" + oFcs.value);
			break;

		case 39:	/* Right arrow */
			iNmd_Signal(sFcsId, "Exp:" + oFcs.value);
			break;
			
		case 38:	/* Up */
			if (!bFirst) oItem = iNmd_TvuPrv(oItem);
			if (oItem) iNmd_TvuClk(oItem, null);
			break;		
		
		case 40:	/* Down */
			if (!bFirst) oItem = iNmd_TvuNxt(oItem);
			if (oItem) iNmd_TvuClk(oItem, null);
			break;		
		
		case 13:	/* Enter */
			document.inomads._eom.value = '\x0D';
			iNmd_Chg(oFcs);
			break;
			
		default:
			return iNmd_CmnKdn(e);
	}

	if (window.event) e.returnValue = false;
	return false;  
}

function iNmd_TvuNxt(oItem)
{	while(oItem)
	{	oItem2 = oItem.firstChild;
		if (!oItem2) oItem2 = oItem.nextSibling;
		while (!oItem2)
		{	oItem2 = oItem.parentNode;	
			if (oItem2.id)
			{	if (oItem2.id.substr(0,3) == 'dv_') return null;
			}

			oItem = oItem2;
			oItem2 = oItem.nextSibling;
		}
		
		oItem = oItem2;
		if (oItem.id)
		{	if (oItem.id.substr(0,3) == 'tx_') break;
		}
	}
	
	return oItem;
}

function iNmd_TvuPrv(oItem)
{	while (oItem)
	{	oItem2 = oItem.previousSibling;
		if (oItem2)
		{	while (oItem2.firstChild)
			{	oItem2 = oItem2.firstChild;
				while (oItem2.nextSibling)
				{	oItem2 = oItem2.nextSibling;
				}
			}
		}
		else
		{	oItem2 = oItem.parentNode;
			if (oItem2.id)
			{	if (oItem2.id.substr(0,3) == 'dv_')  return null;
			}
		}

		oItem = oItem2;
		if (oItem.id)
		{	if (oItem.id.substr(0,3) == 'tx_') break;
		}
	}

	return oItem;
}

function iNmd_TvuPgdn(oItem)
{	var oDiv = i_Id('dv_' + sFcsId);
	if (!oDiv) return null;

	var nDivTop = iNmd_Top(oDiv); 	
	var nItemTop = iNmd_Top(oItem) - nDivTop;
	if (nItemTop < 0) nItemTop = 0;

	var nDivBtm = oDiv.scrollTop + oDiv.clientHeight;
	var nItemBtm = nItemTop + oItem.offsetHeight;
	
	/* If off the screen just exit to resync */
	
	if ((nItemTop < oDiv.scrollTop) || (nItemBtm > nDivBtm))
		return oItem;
	
	var oItem2;
	var bFirst = true;

	while (1)
	{	oItem2 = iNmd_TvuNxt(oItem);
		if (!oItem2) break;
		
		nItemBtm = iNmd_Top(oItem2) - nDivTop + oItem2.offsetHeight;
		if (nItemBtm > nDivBtm)
		{	if (!bFirst) break;
			nDivBtm = nItemTop + oDiv.clientHeight;
		}
			
		oItem = oItem2;
		bFirst = false;
	}
		
	return oItem;
}
			
function iNmd_TvuPgup(oItem)
{	var oDiv = i_Id('dv_' + sFcsId);
	if (!oDiv) return null;

	var nDivTop = iNmd_Top(oDiv); 	
	var nItemTop = iNmd_Top(oItem) - nDivTop;
	if (nItemTop < 0) nItemTop = 0;

	var nDivBtm = oDiv.scrollTop + oDiv.clientHeight;
	var nItemBtm = nItemTop + oItem.offsetHeight;
	
	if ((nItemTop < oDiv.scrollTop) || (nItemBtm > nDivBtm))
		return oItem;
	
	var oItem2;
	var bFirst = true;
	var nItemPos;
	var	nTop = oDiv.scrollTop;
	
	while (1)
	{	oItem2 = iNmd_TvuPrv(oItem);
		if (!oItem2) break;
		
		nItemPos = iNmd_Top(oItem2) - nDivTop;
		if (nItemPos < 0) nItemPos = 0;
		
		if (nItemPos < nTop)
		{	if (!bFirst) break;
			nTop = Math.max(0, nItemTop - oDiv.clientHeight);
		}
			
		oItem = oItem2;
		bFirst = false;
	}
	
	return oItem;
}

function iNmd_TvuRel(oTvu, oItem)
{	var oDiv = i_Id('dv_' + oTvu.id.substr(3));
	if (!oDiv) return 0;
	
	var nDivTop = iNmd_Top(oDiv);
	var nItemTop = iNmd_Top(oItem) - oDiv.scrollTop;
	
	if (nItemTop < 0) return nItemTop;
	
	nItemTop -= oDiv.offsetHeight;
	if (nItemTop > 0) return nItemTop;
	return 0;
}
	
function iNmd_TvuEdit(sId, nRow, sVal)
{	var oCell = i_Id('tx_' + sId + '_' + nRow);
	if (!oCell) return;

	var oLbx = i_Id('id_' + sId);
	if (oFcs != oLbx)
	{	if (!oLbx.tv_sel) oLbx.tv_sel = oRow;
		iNmd_focus(oLbx);
	}

	oLbx.focus();

	var oDiv = i_Id('dv_' + sId);
	iNmd_CellEdit(oCell, 'Grid', oDiv.scrollLeft, oDiv.scrollTop, sVal, '', 0);
}

/* Grid functions */

var oGridCell = null;

function iNmd_GrdClk(oCell)
{	if (oGridCell == oCell) return false;

	var sId = oCell.id.substr(3);
	var nOfs = sId.indexOf('_');

	var oInp = i_Id('id_' + sId.substr(0,nOfs));
	if (!oInp || oInp.disabled) return false;
	oGridCell = null;

	oInp.focus();

	AjxSend('S' + sId.substr(0,nOfs) + ',Clk:' + sId.substr(nOfs+1), 0);
	return false;
}

function iNmd_GrdMnu(e)
{	if (window.event) e = window.event;
	var oCell = e.target ? e.target : e.srcElement;
	
	while (oCell)
	{	if (oCell.id && (oCell.id.substr(0,3) == 'gc_')) break;
		oCell = oCell.parentNode;
	}
	
	if (!oCell) return true;

	var sId = oCell.id.substr(3);
	var nOfs = sId.indexOf('_');
	
	var oInp = i_Id('id_' + sId.substr(0,nOfs));
	if (!oInp) return true;
	
	if (oInp.disabled) return false;
	oInp.focus();
	
	AjxSend('S' + sId.substr(0,nOfs) + ',Mnu:' + sId.substr(nOfs+1), 0);
	
	nMseX = iNmd_Left(oCell) + 2;
	nMseY = iNmd_Top(oCell) + oCell.offsetHeight - 3;

	return e.returnValue = false;
}

function iNmd_GrdBtn(oObj)
{	var oCell = oObj.parentNode;
	while (oCell)
	{	if (oCell.id.substr(0,3) == 'gc_') break;
		oCell = oCell.parentNode;
	}
	if (!oCell) return false;

	oGridCell = oCell;

	var sId = oCell.id.substr(3);
	var nOfs = sId.indexOf('_');

	var oInp = i_Id('id_' + sId.substr(0,nOfs));
	if (!oInp || oInp.disabled) return false;

	oInp.focus();

	AjxSend('S' + sId.substr(0,nOfs) + ',Btn:' + sId.substr(nOfs+1), 0);
	return false;
}

function iNmd_GrdSel(sId, sOpts)
{ return;
}

function iNmd_GrdPos(sId, nRow, nCol, nVscr, sFnc, sCellVal, sCellFmt)
{	var oDiv = i_Id('sv_' + sId);

	if (oDiv)
	{	oDiv.in_ScrollTop = nVscr;
		oDiv.scrollTop = nVscr;
	}

	oDiv = i_Id('sh_' + sId);
	var oCell = i_Id('gc_' + sId + '_' + nRow + '_' + nCol);

	if (oDiv && oCell)
	{	var nDivLeft = iNmd_Left (oDiv);
		var nCellLeft = iNmd_Left(oCell);

		var nMaxScroll = nCellLeft - nDivLeft;
		var nMinScroll = (nCellLeft + oCell.offsetWidth + 7) - (nDivLeft + oDiv.offsetWidth);
	    
		if (oDiv.scrollLeft > nMaxScroll)
		{	oDiv.scrollLeft = nMaxScroll;
		}
		else
		if (oDiv.scrollLeft < nMinScroll)
		{	oDiv.scrollLeft = nMinScroll;
		}
	}
	
	oCell = i_Id('id_' + sId);

	oCell.grd_Fnc = sFnc;
	if (sFnc == 'E')
	{	oCell.grd_Val = sCellVal;
		oCell.grd_Fmt = sCellFmt;
	}
	if (bTrapped) iNmd_Goto('id_' + sId,0);
}

function iNmd_GrdEdit(sId, sVal, sCellFmt, nKey)
{	var oCell = i_Id('gf_' + sId);
	if (!oCell) return;
	if (oCell.className != 'iGridFcs') return;

	var oHs = i_Id('dv_' + sId);
	iNmd_CellEdit(oCell, 'Grid', oHs.scrollLeft, 0, sVal, sCellFmt, nKey);
}
  
function iNmd_GrdDrp(sId, nRow, nCol, nSelected)
{	var oCell = i_Id('gc_' + sId + '_' + nRow + '_' + nCol);
	if (!oCell) return;

	var oHs = i_Id('dv_' + sId);
	var oDiv = document.createElement('div');

	oDiv.className = 'iGridDrop';
	oDiv.style.position='absolute';
	oDiv.style.zIndex = 10;

	var nCellTop = iNmd_Top(oCell);
	oDiv.style.top = nCellTop + oCell.offsetHeight + 'px';
	oDiv.style.left = iNmd_Left(oCell) - oHs.scrollLeft + 'px';

	oDiv.style.width = '100px';
	oDiv.style.height = '100px';

	var nOpts = iNmd_GrdDrp.arguments.length - 4;
	if (nOpts < 1) nOpts = 2;
	if (nOpts > 5) nOpts = 5;
	var sHtml = "<select id='gl_" + sId + "' size=" + nOpts + " class='iGridList'" +
	" onkeydown='iNmd_GrdDrpKdn(event);'" + 
/*	" ondblclick='iNmd_GrdDrpEnd(this);' " + */
	" onclick='iNmd_GrdDrpEnd(this);' " +
	" onblur='iNmd_GrdDrpEnd(this);'>";
	
	nSelected += 4;
	for (var i = 4; i< iNmd_GrdDrp.arguments.length; i++)
	{ sHtml += "<option" + ((i == nSelected) ? " selected='yes'" : "") + " value='"+iNmd_GrdDrp.arguments[i]+"' >" + iNmd_GrdDrp.arguments[i] + "</option>";
	}

	sHtml += "</select>";  
	oDiv.innerHTML = sHtml;

	i_AddNode(oDiv);

	var oList = i_Id('gl_' + sId);
	oList.in_Eom = 0;
	oList.in_Sel = nSelected - 4;
	oList.in_Div = oDiv;

	oList.style.width = oCell.offsetWidth + 'px';
	
	bIsCommon = false;
	oList.focus();
}

function iNmd_GrdDrpKdn(e)
{	var oList = e.target ? e.target : e.srcElement;
	var nKey = (!iNmd_is_ie) ? e.which : e.keyCode;
  
	if ((nKey == 27) || (nKey == 9) || (nKey == 13))
	{	oList.in_Eom = nKey;
		oFcs.focus();
	}
	return true;
}

function iNmd_GrdDrpEnd(oList)
{	for (var i = 0; i < oList.length; i++)
	{	if (oList.options[i].selected)
		{	if (oList.in_Sel != i)
				AjxSend('S' + sFcsId + ',Chg:' + oList.in_Eom + ',' + oList.options[i].value, 0);
			break;
		}
	}
	
	var oDiv = oList.in_Div;
	oList.in_Div = null;
	
	if (oDiv) oDiv.parentNode.removeChild(oDiv);

	oChg = null;
	bIsCommon = true;
	oFcs.focus();
}

/* Folder functions */

function iNmd_TabClk(e)
{	if (window.event) e = window.event;
	var oTab =  e.target ? e.target : e.srcElement;

	while (oTab)
	{	if (oTab.id && (oTab.id.substr(0,3) == 'ft_')) 
		{	if ((oTab.className == 'iTabNormal') || (oTab.className == 'iWtbNrm'))
			{	bFldrPend = true;
				if (oChg != null) iNmd_Chg(oChg);
				bFldrPend = false;
				iNmd_Send(oTab.id.substr(3));
			}
			break;
		}
		oTab = oTab.parentNode;
	}
	return e.returnValue = false;
}

/* Folder tab keydown -- handle left/right arrow */

function iNmd_TabKdn(e, nId)
{	var oTab = e.target ? e.target : e.srcElement;
	var nKeyCode = (!iNmd_is_ie) ? e.which : e.keyCode;
	if (nKeyCode == 9) return iNmd_KdnChkTab(e);

	if ((nKeyCode == 13) && (oTab.tabIndex != 0))
	{	AjxSend('C,13', 0);
	}
	else
	{	var nDir;

		if (!bAutoFolder && (nKeyCode == 32))
		{	iNmd_Send(nId);
			return true;
		}
		else			
		if (nKeyCode == 37)
			nDir = -1;
		else 
		if (nKeyCode == 39)
			nDir = 1;
		else
			return true;
		
		var nStrt = nId;
		while (1)
		{	nId += nDir;
			if (nId == nStrt) return;
			
			if (nId < nMinFolder)
				nId = nMaxFolder;
			else
			if (nId > nMaxFolder)
				nId = nMinFolder;

			oTab = i_Id('id_' + nId);
			if (oTab && (!oTab.disabled)) break;
		}

		if (bAutoFolder)
			iNmd_Send(nId);
		else
			oTab.focus();
	}
	
	if (window.event) e.returnValue = false;
	return false;
}  

/* Query button */
  
function iNmd_Qry(oQry)
{	if (!oQry) oQry = oFcs;

	var sId = oQry.id.substr(3);
	var oMl = i_Id('id_' + sId);

	if (oMl) 
	{	if (oMl.disabled) return false;
		if (oFcs != oMl)
		{	oMl.focus();
			setTimeout(function (){ iNmd_Qry(oFcs); }, 100);
		}
		else
		{	AjxSend('?' + sId + ',0' + iNmd_Val(oMl), 1);
		}
	}
	else 
		alert('Cannot find id_' + sId);
		
	return false;
}
 
/* Common logic -- header resizes and scroll stuff */

var oResizing = null;
var oDivSize = null;
var sIdSize = '';
var sPosSize = '';
var bWidthResize = false;
var nMseDownX = -1;
var nMseDownY = -1;

function iNmd_GrdInHdr(e)
{	if (oDivSize) return;
  
	var oCell = e.target ? e.target : e.srcElement;
	var nRight;
	var nBottom;
	var nOfsCol;

	iNmd_MseXY(e);

	var oId = oCell; //oCell.parentNode;
	while (oId)
	{	if (oId.id != '') break;
		oId = oId.parentNode;
	}

	var sId = oId.id.substr(3);
	sIdSize = sId.substr(0,sId.indexOf('_',0));
	sPosSize = sId.substr(sId.indexOf('_',0)+1);

	bResize = false;

	var oHs = i_Id('dv_' + sIdSize);
	if (!oHs) { alert("Cannot find oHs id:dv_" + sIdSize); }
	var sCur;

	nRight = iNmd_Left(oCell) - oHs.scrollLeft + oCell.offsetWidth;
	nOfsCol = sPosSize.indexOf('_',0);

	if (nMseX >= nRight-4)
	{	bWidthResize = true;
		sCur = 'e-resize';
		if (nOfsCol > 0) sPosSize = sPosSize.substr(nOfsCol+1);
	}
	else
	{	if ((nOfsCol < 0) || (oId.id.substr(0,1) != 'g'))
		{	if (oResizing) iNmd_GrdOutHdr(e);
			return;
		}

		nBottom = iNmd_Top(oCell) + oCell.offsetHeight;
		if (nMseY >= nBottom-4)
		{	bWidthResize = false;
			sCur = 'n-resize';
			sPosSize = sPosSize.substr(0, nOfsCol);
		}
		else
		{	if (oResizing) iNmd_GrdOutHdr(e);
			return;
		}
	}

	document.body.style.cursor = sCur;

	oCell.onmouseout = iNmd_GrdOutHdr;
	oCell.onmousedown = iNmd_HdrSzStrt;

	oResizing = oCell;
	bResize = true;
}

function iNmd_GrdOutHdr(e)
{	if (oDivSize) return;
	bResize = false;
	
	if (oResizing)
	{	oResizing.onmousedown = null;
		oResizing.onmouseout = null;

		document.body.style.cursor = 'auto';
		oResizing = null;
	}  
	return;
}

function iNmd_HdrSzStrt(e)
{	if (oDivSize) return;
	if (oResizing == null) return;
  
	if (window.event) e = window.event;

	iNmd_MseXY(e);
	nMseDownX = nMseX;
	nMseDownY = nMseY;

	var oDiv = i_Id('dw_' + sIdSize);
	if (!oDiv) { alert('Cannot find dw_' + sIdSize); return; }

	oDivSize = document.createElement('div');

	oDivSize.style.position='absolute';

	if (bWidthResize)
	{	var oHs = oResizing.parentNode;
		var scrollLeft = 0;
		
		while (oHs)
		{	if (oHs.id.substr(0,3) == 'dv_') 
			{	scrollLeft = oHs.scrollLeft;
				break;
			}
			
			if (oHs == oDiv) break;
			oHs = oHs.parentNode;
		}


		oDivSize.style.top = iNmd_Top(oDiv)  + (bSafari ? 1 : 0) + 'px';
		oDivSize.style.left = iNmd_Left(oResizing) - scrollLeft + (bSafari ? 2 : 0) + 'px';

	    oDivSize.style.height = oDiv.offsetHeight + 'px';
		oDivSize.style.width = oResizing.offsetWidth + 'px';

		oDivSize.className = 'iCmnSizeH';
	}
	else
	{	oDivSize.style.top = iNmd_Top(oResizing)  + (bSafari ? 1 : 0) + 'px';
		oDivSize.style.left = iNmd_Left(oDiv)  + (bSafari ? 2 : 0) + 'px';
	
		oDivSize.style.height = oResizing.offsetHeight + 'px';    
		oDivSize.style.width = oDiv.offsetWidth + 'px';

		oDivSize.className = 'iCmnSizeV';
	}
  
	i_AddNode(oDivSize);

	if (window.addEventListener)
	{	window.addEventListener('mouseup', iNmd_HdrSzEnd, true);
		window.addEventListener('mousemove', iNmd_HdrSzChg, true);
	}
	else
	{	document.attachEvent('onmouseup', iNmd_HdrSzEnd);
		document.attachEvent('onmousemove', iNmd_HdrSzChg);
	}

	if (window.event) e.returnValue = false;
	return false;
}

function iNmd_HdrSzChg(e)
{	if (!oDivSize) return;

	var nSize;

	iNmd_MseXY(e);
	if (bWidthResize)
	{	nSize = oResizing.offsetWidth + nMseX - nMseDownX;
		if (nSize < 1) nSize = 1;

		oDivSize.style.width = nSize + 'px';
	}
	else
	{	nSize = oResizing.offsetHeight + nMseY - nMseDownY;
		if (nSize < 1) nSize = 1;

		oDivSize.style.height = nSize + 'px';
	}

	if (window.event)
		window.event.cancelBubble = true;
	else
		e.stopPropagation();

	return false;
}

function iNmd_HdrSzEnd(e)
{	var sAdj;
	if (bWidthResize)
		sAdj = 'Wide:' + oDivSize.offsetWidth;
	else
		sAdj = 'High:' + oDivSize.offsetHeight;

	if (sPosSize.substr(0,1) == 'N') sPosSize = '-' + sPosSize.substr(1);

	if (window.addEventListener)
	{	window.removeEventListener('mouseup', iNmd_HdrSzEnd, true);
		window.removeEventListener('mousemove', iNmd_HdrSzChg, true);
	}
	else
	{	document.detachEvent('onmouseup', iNmd_HdrSzEnd);
		document.detachEvent('onmousemove', iNmd_HdrSzChg);
	}

	if (oDivSize) oDivSize.parentNode.removeChild(oDivSize);
	oDivSize = null;
	bResize = false;
	
	AjxSend('S' + sIdSize + ',' + sAdj + ',' + sPosSize, 0); 

	if (oFcs && oFcs.focus) oFcs.focus();
	iNmd_GrdOutHdr(e); 

	if (window.event)
		window.event.cancelBubble = true;
	else
		e.stopPropagation();
	return false;
}

function iNmd_VSGo(sId, nOfs)
{	var	oObj = i_Id(sId);

	if (!oObj) return;
	if (oObj.in_sts) return;
		
	oObj.in_ign = 1;
	oObj.scrollTop = nOfs;

	return;
}

function iNmd_VS(oObj)
{	if (oObj.in_ign)
	{	oObj.in_ign=false;
		return;
	}
	
	if (!oObj.in_sts)
	{	oObj.in_sts = 1;
		AjxSend('S' + oObj.id.substr(3) + ',Vsc:' + oObj.scrollTop, -1);
	}
	else
	{	oObj.in_sts = 2;
	}
	return;
}

function iNmd_VSOK(sId)
{	var oObj = i_Id(sId);
	if (!oObj) return;

	if (oObj.in_sts == 2)
	{	oObj.in_sts = 1;
		AjxSend('S' + oObj.id.substr(3) + ',Vsc:' + oObj.scrollTop, -1);
	}
	else
	{	oObj.in_sts = 0;
	}

	return;
}
		
function iNmd_Goto(sId, bRetry)
{	document.inomads._eom.value = '';
	var oCtl = i_Id(sId);
	
	if (!oCtl) return;
	if (oCtl.disabled) 
	{	sTabFcs = null;
		return;
	}

	if (oFcs)
	{	if (oFcs != oCtl) iNmd_Restore(oFcs);	/* Not perfect since its possible on focus has occured */
	}
	
	oCtl.in_retry = bRetry;

	iNmd_SetFcs(oCtl);
	if (bRetry) oChg = oCtl;
	
	oCtl.focus();
	if (oCtl.type == 'text') iNmd_Select(oCtl);
	
	bTrapped = false;
}

function iNmd_Select(oCtl)
{	if (oCtl.type != 'text')
	{	if (oCtl.type != 'password') return;
	}
	
	if ((document.selection) && (!bOpera))
	{	var oRng = document.selection.createRange();
		if (oRng)
		{	oRng.moveStart("character", -100000);
			oRng.moveEnd("character", 100000);
			oRng.select();
		}
	}
	else
	if ('selectionStart' in oCtl)
	{	oCtl.selectionStart = 0;
		oCtl.selectionEnd = oCtl.value.length;
	}
}

function iNmd_CmnLoad(sId, sHtml)
{	var oTbl = i_Id(sId);
	if (!oTbl)
	{	alert('Cannot find ' + sId + ' (CmnLoad)');
		if (!bAjxDmp) AjxDump();
		return;
	}
	
	nClickMS = 0;
	oClick = null;
	
	var oDiv;

	if (sHtml != '')
	{	var nScroll;  
		oDiv = i_Id('sh_' + sId.substr(3));
		if (oDiv) nScroll = oDiv.scrollLeft;
		
		oTbl.innerHTML = sHtml;

		if (nScroll)
		{	oDiv = i_Id('sh_' + sId.substr(3));
			if (oDiv) 
			{	oDiv.scrollLeft = nScroll;
				var oTbl = i_Id('dv_' + sId.substr(3));
				if (oTbl) oTbl.scrollLeft = nScroll;
			}
		}
	}
		
	oDiv = i_Id('sv_' + sId.substr(3));
	if (oDiv) 
	{	oDiv.in_ScrollPend = false;
		if (oDiv.in_ScrollMore) iNmd_CmnVs(oDiv);
	} 

	if ((oFcs == oTbl) && bIsCommon && (!bIphone)) oFcs.focus(); 
	
}

function iNmd_CmnChg(sId, sHtml, sClass, sColor)
{	var oTbl = i_Id(sId);

	if (oTbl)
	{	if (sClass && (sClass != '')) oTbl.className = sClass;
		if (sColor) 
		{	if (sColor == '') 
				oTbl.style.backgroundColor = null;
			else	
				oTbl.style.backgroundColor = sColor;
		}

		if (sHtml != '')
		{	if (sHtml.substr(0,1) == '^')
			{	while (oTbl)
				{	if ((oTbl.nodeName == 'TD') || (oTbl.id == 'iQry'))
					{	oTbl.innerHTML = sHtml.substr(1);
						break;
					}
					oTbl = oTbl.parentNode;
				}
			}
			else
			if (sHtml.substr(0,1) == '!')
			{	oTbl = oTbl.parentNode;
				oTbl.innerHTML = sHtml.substr(1);
			}
			else
			{	oTbl.innerHTML = sHtml;
			}

			if (sId.substr(0,3) == 'gc_') iNmd_GrdCellShow(sId.substr(3,5));
		}

		if ((oFcs == oTbl) && bIsCommon && (!bIphone)) oFcs.focus(); 

	}
	else
	{	alert('Cannot find ' + sId + ' (CmnChg)' );
		if (!bAjxDmp) AjxDump();
	}
}

function iNmd_GrdCellShow(sId)
{	var oCell = i_Id('gf_' + sId);
	if (!oCell) return;
	
	var oDivHS = i_Id('dv_' + sId);
	if (!oDivHS) return;

	var nScroll = oDivHS.scrollLeft;
		
	var	nDivLeft = iNmd_Left(oDivHS);
	var nCellLeft = iNmd_Left(oCell);

	var nDivRight = nDivLeft + oDivHS.offsetWidth;
	var nCellRight = nCellLeft + oCell.offsetWidth;

	if ((nCellRight - nScroll) > nDivRight)
	{	nScroll = nCellRight - nDivRight;
	}
	
	if ((nCellLeft - nScroll) < nDivLeft)
	{	nScroll = nCellLeft - nDivLeft;
	}
	
	
	if (nScroll != oDivHS.scrollLeft)
	{	var oDiv = i_Id('sh_' + sId);
		if (oDiv) oDiv.scrollLeft = oDivHS.scrollLeft = nScroll;
	}
	return;
}

function iNmd_Msgbar(sHtml, nBar)
{	var oHtml;

	if (typeof user_Msgbar == 'function')
	{	if (user_MsgBar(sHtml, nBar)) return;
	}
	
	oHtml = i_Id('MsgBar' + (nBar > 0 ? nBar.toString(10) : ''));
	if (oHtml) oHtml.innerHTML = sHtml;
}

function iNmd_CmnVs(oDiv)
{	if (oDiv.in_noVScr) 
	{	oDiv.in_noVScr = false;
		return;
	}
	
	if (oDiv.in_ScrollTop == oDiv.scrollTop) return;
	
	if (oDiv.in_ScrollPend)
	{	oDiv.in_ScrollMore = true;
	}
	else
	{	oDiv.in_ScrollPend = true;
		oDiv.in_ScrollMore = false;
		oDiv.in_ScrollTop = oDiv.scrollTop;
		
		AjxSend('S' + oDiv.id.substr(3) + ',Vsc:' + oDiv.scrollTop, 0);
	}

	return;
}

function iNmd_CmnHs(oDiv)
{	var sId = oDiv.id.substr(3);
	var oDiv2 = i_Id('dv_' + sId);

	if (oDiv2)
	{	oDiv2.scrollLeft = oDiv.scrollLeft;
		if (oFcs && bIsCommon) oFcs.focus();
	}
	else
		alert('Cannot find dv_'+sId);
	return;
}

function iNmd_CmnWhl(sId, event)
{	var nChg = 0;
 
	if (!event) event = window.event;

	if (event.wheelDelta)
	{	nChg = event.wheelDelta / 120;
	}
	else
	if (event.detail)
	{	nChg = (0 - event.detail) / 3;
	}

	var oDiv = i_Id('sv_' + sId);
	if (oDiv)
	{	var oRow = (event.target ? event.target : event.srcElement);
	
		while (oRow && !oRow.offsetHeight)
		{	oRow = oRow.parentNode;
		}
		
		if (oRow)
			nChg *= oRow.offsetHeight * 3;
		else
			nChg *= 40;
			
		nChg = oDiv.scrollTop - nChg;
		if (nChg == 0) nChg = 0;
		if (nChg > oDiv.scrollHeight) nChg = oDiv.scrollHeight;
		
		if (!oDiv.in_ScrollPend)
		{	if (nChg != oDiv.scrollTop)
			{	oDiv.scrollTop = nChg;
				iNmd_CmnVs(oDiv);
			}
		}
				
		if (event.stopPropagation) event.stopPropagation();
		if (event.preventDefault) event.preventDefault();
		event.cancelBubble = true;
        event.cancel = true;
		return event.returnValue = false;
	}
}

function iNmd_CmnScr(sId, nVscr)
{	var oDiv = i_Id('sv_' + sId);
	if (!oDiv)
	{	oDiv = i_Id('vb_' + sId);
		if (oDiv) 
		{	oDiv.in_ScrollTop = nVscr;
			var nSz = (nVscr * oDiv.offsetHeight) / parseInt(oDiv.getAttribute('iHi'), 10);
			i_Id('vp_' + sId).style.height = nSz + 'px';
		}
		return;
	}
			
	if (!oDiv.in_ScrollPend)
	{	//oDiv.in_noVScr = true;
		oDiv.in_ScrollTop = nVscr;
		oDiv.scrollTop = nVscr;
//		oDiv.in_noVScr = false;
	}
	
	return;
}

function iNmd_CmnKdn(e)
{	if (window.event) e = window.event;

	var nKey = (e.which) ? e.which : e.keyCode;
	var sKey;

	switch (nKey)
	{	case 13: sKey = 'CR'; break;	/* Enter */
		case 33: sKey = 'PGUP'; break;	/* PgUp */
		case 34: sKey = 'PGDN'; break;	/* PgDn */
		case 35: sKey = 'END'; break;	/* End */
		case 36: sKey = 'HOME'; break;	/* Home */
		case 37: sKey = 'LEFT'; break;	/* Left */
		case 38: sKey = 'UP'; break;	/* Up */
		case 39: sKey = 'RIGHT'; break;	/* Right */
		case 40: sKey = 'DOWN'; break;	/* Down */
		case 45: sKey = 'INS'; break;	/* Insert */
		case 46: sKey = 'DEL'; break;	/* Delete */
		case 9:
			iNmd_TabTrap();  
			bRefocus = true;
			sKey = 'TAB'; 
			break;	/* Tab */
			
		default:
			if (e.altKey)
			{	if ((nKey >= 112) && (nKey <= 123))
				{	AjxSend('K' + (nKey - 111));
					return e.returnValue = false;					
				}
			}
				
			return true;
	}

	sKey += ',' + (e.ctrlKey ? 'C' : '') + (e.shiftKey ? 'S' : '');  	
	AjxSend('S' + oFcs.id.substr(3) + ',Kdn:' + sKey, 0);  

	if (window.event) e.returnValue = false;
	return false;  
}

function iNmd_CmnKey(e)
{	var nKey;
	if (bFireFox)
	{	nKey = e.charCode;	
		if (nKey == 0) if (e.keyCode == 9) return true;
	}
	else
	if (bOpera)
		nKey = e.which;
	else
		nKey = e.keyCode;
		
	if (nKey == 9) return true;
	
	if (window.event) e.returnValue = false;
	
	if ((nKey >= 32) && (nKey != 127))
	{	if (oFcs.grd_Fnc)
		{	if (oFcs.grd_Fnc == 'E')
			{	iNmd_GrdEdit(oFcs.id.substr(3), oFcs.grd_Val, oFcs.grd_Fmt, nKey);
				return false;
			}
			if (oFcs.grd_Fnc == 'I')
				return false;
		}
		AjxSend('S' + oFcs.id.substr(3) + ',Key:' + nKey, 0);  
	}
	
	return false;  
}

function iNmd_CellEdit(oCell, sCls, scrollLeft, scrollTop, sVal, sCellFmt, nKey)
{	if (oCellEdit) iNmd_CellEdtEnd(27, null);

	var oDiv = document.createElement('div');

	oDiv.id = 'ce_Div'; 
	oDiv.className = 'i' + sCls + 'Fcs';
	oDiv.style.position='absolute';
	
	oDiv.style.left = iNmd_Left(oCell) - scrollLeft + (bSafari ? 1 : 1) + 'px';
	oDiv.style.top = iNmd_Top(oCell) - scrollTop + (bSafari ? -1 : 0) + 'px';
	oDiv.style.width = oCell.offsetWidth + 'px';
	oDiv.style.height = oCell.offsetHeight + 'px';

	var sSfx = (sCellFmt == '') ? '' : '_FMT';
	
	var sHtml = '<input type=\'text\' id=\'ce_Text\' class=\'i' + sCls + 'Edit\' style=\'width:' +
		(oCell.offsetWidth) + 'px; border:none; background: transparent;\'' +
		' onblur=\'iNmd_CellEdtEnd(0, event);\'' + 
		' onkeydown=\'return iNmd_kdn' + sSfx +'(event);\'' + 
		' onkeypress=\'return iNmd_key' + sSfx + '(event);\' />'

	oDiv.innerHTML = sHtml;  
	i_AddNode(oDiv);

	oCellEdit = i_Id('ce_Text');

	if ((nKey) && (sCellFmt == ''))
	{	sVal = String.fromCharCode(nKey);
		nKey = -1;
	}

	sFmt = sCellFmt;
	oFcs.in_fmt = sCellFmt;

	oCellEdit.value = sVal;
	oCellEdit.focus();
	
	if ((document.selection) && (!bOpera))
	{	var oRng = document.selection.createRange();
		if (oRng)
		{	oRng.moveStart("character", -100000);
			if (nKey == -1)
			{	oRng.moveStart("character", 1);
			}
			
			oRng.moveEnd("character", 100000);
			oRng.select();
		}
	}
	else
	if ('selectionStart' in oCellEdit)
	{	if (nKey == -1)
		{	oCellEdit.selectionStart = 1;
			oCellEdit.selectionEnd = 1;
		}
		else
		{	oCellEdit.selectionStart = 0;
			oCellEdit.selectionEnd = sVal.length;
		}
	}

	if (nKey > 0)
	{	oCellEdit.target = oCellEdit; 
		iNmd_fmtchr(oCellEdit, nKey);
	}
}  

function iNmd_CellEdtEnd(nKey, e)
{	var oText = oCellEdit;
	if (!oText) return;
	
	oCellEdit = null;
	oText.onkeydown = null;
	oText.onkeypress = null;
	
	oChg = null;
	var oDiv = i_Id('ce_Div');
	if (oDiv) oDiv.parentNode.removeChild(oDiv);
	
	oFcs.focus();

	if (nKey != 27)
	{	if (nKey == 9) iNmd_TabTrap();
		AjxSend('S' + sFcsId + ',Chg:' + nKey + ',' + oText.value, 0);
		if (nKey == 9) iNmd_CmnKdn(e);
	}
}  

/* Popup menu functions */

var bPopup = false;
var oMbar = null;
var oMbarDiv = null;

function iNmd_Popup(sMenu)
{	var oMnu = new iMnu(sMenu);
	bPopup = true;
	iMnu_Show(null, oMnu, ''); 
}

function iNmd_Mbar(sMenu)
{	if (!oMbarDiv)
	{	oMbarDiv = i_Id('id_Mbar');
		if (!oMbarDiv) return;
	}
	
	if (sMenu == '')
	{	oMbarDiv.style.display = 'none';
		oMbarDiv.innerHTML = '';
		oMbarDiv = null;
		oMbar = null;
		return;
	}
	
	oMbar = new iMnu(sMenu);
	iMnu_Show(null, oMbar, '');
}

function iNmd_MbarChg(sId, sSts)
{	var nMnu;
	if (!oMbar) return;

	var subMenu = sId.substr(0,sId.length-1);
	
	for (nMnu = 0; nMnu < oMbar.subMenu.length; nMnu++)
	{	if (oMbar.subMenu[nMnu] == subMenu) break;
	}

	if (nMnu >= oMbar.subMenu.length) { alert('Cannot find menu group'); return; }

	var sText = oMbar.subText[nMnu];
	var sCd = sId.substr(sId.length-1);
	
	var nIdx = sText.toUpperCase().indexOf('&' + sCd,0);
	if (nIdx < 0) { alert('Cannot find sub-menu entry'); return; }
	
	nIdx = sText.indexOf('=',nIdx);
	if (nIdx < 0) { alert('Cannot find ='); return; }
	
	var sPre = sText.substr(0,nIdx);
	var sOpt = sText.substr(nIdx);

	nIdx = sOpt.indexOf(',',0);
	if (nIdx == -1)
	{	sText = '';
	}
	else
	{	sText = sOpt.substr(nIdx);
		sOpt = sOpt.substr(0,nIdx);
	}
	
	nIdx = sOpt.indexOf(sSts.substr(1));
	
	if (sSts.substr(0,1) == '+')
	{	if (nIdx == -1) sOpt += sSts.substr(1);
	}
	else
	{	sOpt = sOpt.substr(0,nIdx) + sOpt.substr(nIdx+1);
	}
	
	oMbar.subText[nMnu] = sPre + sOpt + sText;
	if (sId.length <= 1) iMnu_Show(null, oMbar, '');
	return;	
}

function iMnu_Show(oNear, oMnu, subMenu)
{	var oDiv;
	var sHtml;
	var sText;
	var sLine;
	var nIdx;
	var nNext;
	var sCol1, sCol2, sCol3;
	var lImg, sImg;
	var sOpt;
	var bDisabled;
	var nMnu;
	var nId;
	var sId;

	for (nMnu = 0; nMnu < oMnu.subMenu.length; nMnu++)
	{	if (oMnu.subMenu[nMnu] == subMenu) break;
	}

	if (nMnu >= oMnu.subMenu.length) return;
  
	if ((oMnu == oMbar) && (subMenu == ''))
	{	oDiv = oMbarDiv;
		if (!oDiv) return;
	}
	else
	{	oDiv = document.createElement('div');
		oDiv.className = 'iMenuDiv';
		oDiv.style.zIndex = 10;

		//set the inner styling of the div tag 

		oDiv.style.position="absolute";

		if (!oMnuDiv)
		{	if (iNmd_is_ie)
			{	document.attachEvent("onmousedown", iMnu_MseClr);
				document.attachEvent("onkeydown", iMnu_Clear);
			}
			else
			{	window.addEventListener("mousedown", iMnu_MseClr, true);
				window.addEventListener("keydown", iMnu_Clear, true);
			}
		}
		
		if ((!oNear) && (nMseX <= 0)) oNear = oFcs;
		
		if (oNear)
		{	if (oMnuDiv)
			{	oDiv.style.left = iNmd_Left(oNear) + oNear.offsetWidth + 'px';
				oDiv.style.top = iNmd_Top(oNear) + 'px';
			}
			else
			{	oDiv.style.left = iNmd_Left(oNear) + 'px';
				oDiv.style.top = iNmd_Top(oNear) + oNear.offsetHeight + 'px';
			}
		}
		else
		{	oDiv.style.left = nMseX + 'px';
			oDiv.style.top = nMseY + 'px';
		}

		oDiv.in_oMnuParent = oMnuDiv;
		oMnuDiv = oDiv;
	}
		
	oDiv.in_oMnu = oMnu;
	oDiv.in_nMnu = nMnu;

	sText = oMnu.subText[nMnu] + ',';

	sHtml = '';
	nIdx = 0;

	nNext = -1;

	while (1)
	{	nIdx = nNext + 1;

		nNext = sText.indexOf(',', nIdx);
		if (nNext < 0) break;

		sLine = sText.substring(nIdx, nNext);

		if (sLine == '') 
		{	if (oDiv != oMbarDiv) sHtml += '<tr><td colspan=\'3\'><hr></td></tr>';
			continue;
		}

		sCol1 = '';
		sCol2 = '';

		nIdx = sLine.indexOf('{');
		if (nIdx != -1)
		{	sImg = sLine.substr(nIdx + 1);
			lImg = sImg.indexOf('}');
			if (lImg != -1)
			{	sCol1 = '<img src="' + sImg.substr(0,lImg) + '">';
				sLine = sLine.substr(0, nIdx) + sImg.substr(lImg+1);
			}
		}
		
		sCol3 = '&nbsp;&nbsp;';
		bDisabled = false;

		nIdx = sLine.indexOf('=',0);
		if (nIdx < 0)
		{	sCol2 = sLine;
			sOpt = '';
		}
		else
		{	sCol2 = sLine.substr(0,nIdx);
			sOpt = sLine.substr(nIdx+1).toUpperCase();
		}

		nIdx = sCol2.indexOf('&');

		nId = 0;

		if (nIdx < 0) 
			sId = 'Err';
		else
		{	sId = oMnu.subMenu[nMnu] + sCol2.charAt(nIdx+1).toUpperCase();
			for (var i = 0; i < oMnu.length; i++)
			{	if (sId == oMnu.subMenu[i])
				{	sCol3 = '&nbsp;&#9658;&nbsp;';
					break;
				}
			}
		}

		sCol2 = iNmd_HTML(sCol2.substr(0,nIdx) + sCol2.substr(nIdx+1));
		
		if (sOpt != '')
		{	var nIdx = sOpt.indexOf('C');
			if (nIdx != -1)
			{	sCol1 = '&#10003;';
				sOpt = sOpt.substr(0, nIdx) + sOpt.substr(nIdx+1);
			}
		    
			nIdx = sOpt.indexOf('B');
			if (nIdx != -1)
			{	sCol2 = '<strong>' + sCol2 + '</strong>';
				sOpt = sOpt.substr(0, nIdx) + sOpt.substr(nIdx+1);
			}
		    
			nIdx = sOpt.indexOf('G');
			if (nIdx != -1)
			{	sCol3 = '&nbsp;&#9658;&nbsp;';
				sOpt = sOpt.substr(0, nIdx) + sOpt.substr(nIdx+1);
			}
		    
			nIdx = sOpt.indexOf('D');
			if (nIdx != -1)
			{	bDisabled = true;
				sOpt = '';
			}
		    
			nId = parseInt(sOpt, 10);
		}

		nIdx = sCol2.indexOf('\t');
		if (nIdx != -1)
		{	sCol3 = sCol2.substr(nIdx+1) + sCol3;
			sCol2 = sCol2.substr(0, nIdx);
		}
		
		if (oDiv == oMbarDiv)
		{	if (bDisabled)
			{	sHtml += '<span class=\'iMenuDis\'>&nbsp;' + sCol2 + '&nbsp;</span>';
			}
			else
			{	sHtml += '<span class=\'iMenu\' onclick=\'iMnu_Click(event,"' + sId + '",' + nId + ');\'>&nbsp;' + sCol2 + '&nbsp;</span>';
			}
		}
		else
		{	if (bDisabled)
			{	sHtml += '<tr class=\'iMenuDis\'>';
			}
			else
			{	sHtml += '<tr class=\'iMenu\' onclick=\'iMnu_Click(event,"' + sId + '",' + nId + ');\'>';
			}

			sHtml += '<td width=\'20\'>' + sCol1 + '</td><td>' + sCol2 + '</td><td>' + sCol3 + '</td></tr>';
		}
	}

	if (oDiv == oMbarDiv)
	{	oDiv.innerHTML = sHtml;
		oDiv.className = 'iMenuDiv';
		oDiv.style.display = 'block';
		return;
	}
	
	oDiv.innerHTML = '<table cellspacing=\'0\'>' + sHtml + '</table>';
	
	i_AddNode(oDiv);
	setTimeout(iMnu_Pos, 10);
}

function iMnu_Pos()
{	var nLeft, nTop;
	if (!oMnuDiv) return;
	
	iNmd_GetSize();
	
	nLeft = iNmd_Left(oMnuDiv);
	nTop = iNmd_Top(oMnuDiv);

	if ((nLeft + oMnuDiv.offsetWidth + 10) >  wdwWd)
	{	if (oMnuDiv.in_oMnuParent) nLeft = iNmd_Left(oMnuDiv.in_oMnuParent);
		nLeft -= oMnuDiv.offsetWidth;
			
		oMnuDiv.style.left = nLeft + 'px';
	}

	if ((nTop + oMnuDiv.offsetHeight + 4) >  wdwHi)
	{	nTop = wdwHi - oMnuDiv.offsetHeight - 4;
		oMnuDiv.style.top = nTop + 'px';
	}
}

function iMnu_Click(e, sId, nId)
{	var oTr;
	var oDiv;

	if (window.event)
	{	e = window.event;
		e.returnValue = false;
	}

	if (e.target) oTr = e.target; else oTr = e.srcElement;

	while (oTr)
	{	if (oTr.className == 'iMenu') break;
		oTr = oTr.parentNode;
	}

	if (!oTr) return false;

	oDiv = oTr.parentNode;

	while (oDiv)
	{	if (oDiv.in_oMnu) break;
		oDiv = oDiv.parentNode;
	}

	if (!oDiv) { alert('Cannot find div'); return false; }

	var oMnu = oDiv.in_oMnu;

	for (var nMnu = 0; nMnu < oMnu.length; nMnu++)
	{	if (oMnu.subMenu[nMnu] == sId) break;
	}

	if (nMnu >= oMnu.length)
	{	bPopup = false;
		AjxSend('M' + nId + ',' + sId);

		iMnu_Pop(null);
		return false;
	}

	if (oDiv.in_hilite) oDiv.in_hilite.className = 'iMenu';
	oDiv.in_hilite = oTr;
	oTr.className = 'iMenuOpen';

	iMnu_Pop(oDiv);
	iMnu_Show(oTr, oMnu, sId);

	return false;
}

function iMnu_MseClr(e)
{ var oObj;
  if (window.event) e = window.event;
  if (e.target) oObj = e.target; else oObj = e.srcElement;
  
  while (oObj)
  { if (oObj.in_oMnu) return;
    oObj = oObj.parentNode;
  }
  
  iMnu_Clear();
}

function iMnu_Clear()
{	iMnu_Pop(null);
	if (bPopup)
	{	AjxSend('M0,');
		bPopup = false;
	}
}
  
function iMnu_Pop(oDiv)
{	var oNxtDiv;
	
	if ((oDiv == null) && oMbarDiv)
	{	if (oMbarDiv.in_hilite)
		{	oMbarDiv.in_hilite.className = 'iMenu';
			oMbarDiv.in_hilite = null;
		}
	}
	
	while (oMnuDiv)
	{	if (oMnuDiv == oDiv) break;

		oNxtDiv = oMnuDiv.in_oMnuParent;
		oMnuDiv.parentNode.removeChild(oMnuDiv);
		oMnuDiv = oNxtDiv;
		if (oMnuDiv == null)
		{	if (iNmd_is_ie)
			{	document.detachEvent("onmousedown", iMnu_MseClr);
				document.detachEvent("onkeydown", iMnu_Clear);
			}
			else
			{	window.removeEventListener("mousedown", iMnu_MseClr, true);
				window.removeEventListener("keydown", iMnu_Clear, true);
			}
		}
	}

  return;
}

/* ============ iMnu object definition ========= */

function iMnu(sMenu)
{ var nStrt;
  var nFini;
  var nNext;
  var nImg;
  var lImg;
    
  var sMnu;
  var chMnu;
  var sImg;
  
  this.subMenu = new Array();
  this.subText = new Array();
  
  this.length = 0;
  
  nStrt = 0;
  while (1)
  { nNext = sMenu.indexOf('[', nStrt);
    if (nNext < 0) break;
    
    nFini = sMenu.indexOf(']', nNext);
    if (nFini < 0)
    { alert('Bad menu: ' + sMenu);
      break;
    }
  
	sMnu = sMenu.substring(nNext+1, nFini);
    this.subText[this.length] = sMnu;
    
    sMnu = '';
    if ((nNext > 0) && (sMenu.charAt(nNext-1) == ':'))
    { nNext--;
      while (nNext > 0)
      { chMnu = sMenu.charAt(--nNext);
        if ((chMnu == ',') || (chMnu == ']')) break;
        sMnu = chMnu + sMnu;
      }
    }
    
    this.subMenu[this.length] = sMnu.toUpperCase();
    
    this.length++;
    nStrt = nFini + 1;
  }
} 

/* *** Utility functions *** */

function iNmd_Signal(nId, sId)
{	AjxSend('S' + nId + ',' + sId,0);
}

function PropDump(objectname, object) 
{	var wNew = window.open('','','height=600,width=800,toolbar=no,directories=no,status=no,menubar=no,scrollbars=yes,resizable=yes,location=no');
	var sVal;
	
	wNew.document.writeln('<html><body>');

	wNew.document.writeln("<table border=1 bgcolor=wheat><tr>");
	wNew.document.writeln("<td style='font-size: 18pt; font-weight: bold' colspan=2 align=center>");
	wNew.document.writeln("Properties of the <code>"+objectname+"</code> object</td></tr>");

	for (prop in object)
	{	if ((prop == 'innerHTML') || (prop == 'outerHTML'))
			sVal = "..suppressed..";
		else
			sVal =  object[prop];

		wNew.document.writeln("<tr><th>"+prop+"</th><td>" +  sVal +"</td></tr>");
	}

	wNew.document.writeln("</table><p>");
	wNew.document.writeln('</body></html>');
	wNew.document.close();
	return;
}

function iNmd_Top(oElm)
{	var y = parseInt(oElm.offsetTop);

	while (oElm = oElm.offsetParent)
	{	y += parseInt(oElm.offsetTop);
	}
	return y;
}

function iNmd_Left(oElm)
{	var x = parseInt(oElm.offsetLeft);
	while (oElm = oElm.offsetParent)
	{	x += parseInt(oElm.offsetLeft);
	}
	return x;
}

/* Window management */

var oChild;
var oDivMask = null;
var nBlocked = 0;

function iNmd_push(sSeq, nX, nY, nWd, nHi, sOpts)
{	iNmd_MaskScrn();
	
	oDivMask.onclick = iNmd_pop;

	if (oChild && oChild.closed) oChild = null;
	
	if (sSeq == 'Push')
	{	if (oChild) return;
	}
	
	AjxSeq++;

	if (nY < 0)
	{	nY = 0 - nY;
		
		if (nX < 0)
		{	nX = 0;
			if (oFcs)
			{	nY += iNmd_Top(oFcs);
				nX += iNmd_Left(oFcs);
			}
		}
				
		if (window.screenTop)
		{	nY = window.screenTop + nY;
			nX = window.screenLeft + nX;
		}
		else
		{	nY = window.screenY;
			nX = window.screenX + nX;
		}
	}
	else
	if (nX < 0)
	{	nX = (window.screen.availWidth - nWd) / 2;
		nY = (window.screen.availHeight - nHi - 20) / 2;
	}

	var oWdw = window.open(window.location.pathname + 
							'?_session=' + document.inomads._session.value +
							'&_seq=' + sSeq + '&_x=' + AjxSeq,
							'',	'top=' + nY +
							',left=' + nX +
							',height=' + nHi +
							',width=' + nWd +
							',modal' + (sOpts ? ',' + sOpts : '') );
/*							
							',toolbar=no,directories=no,location=0,status=0,menubar=no,scrollbars=yes,resizable=yes');
*/
	if (!oWdw)
	{	nBlocked++;
		if ((nBlocked % 10) == 1)
		{	alert("Unable to launch window.  Please disable your popup blocker for this site.");
		}
		
		setTimeout('iNmd_push("'+sSeq+'",'+nX+','+nY+','+nWd+','+nHi+');', 1000);
	}
	else
		nBlocked = 0;
	
	if (sSeq == 'Push') oChild = oWdw;
	
	return;
}

function iNmd_pop()
{	if (oChild)
	{	if (oChild.closed)
		{	iNmd_resume('');
		}
		else
		{	oChild.AjxSend('C-1999,0');
		}
	}
	
	return;
}

function iNmd_Rscu()
{	window.onunload = null;
	window.onbeforeunload = null;
	if (window.opener)
	{	window.close();
	}
	else
	{	window.location = 'syshtml/sys_rescued.htm';
	}
}

function iNmd_resume(sSeq)
{	if (sSeq != '') document.inomads._seq.value = sSeq;
	
	iNmd_UnMask();

	if (oChild)
	{	if (!oChild.closed) oChild.close();
	
		oChild = null;
	}

	AjxSend('X',-1);
	return;
}

function iNmd_close(sSeq)
{	if (document.inomads._seq.value != sSeq)
	{	iNmd_UnMask();
		AjxSend('X',1);
		return;
	}

	try
	{	if (window.opener.oChild == window)
		{	window.onunload = null;
			window.onbeforeunload = null;
			window.close();
			
			window.opener.iNmd_resume(sSeq);
			return;
		}
	}
	catch(err)
	{
	}
	
	{	document.inomads._seq.value='Exit';
		iNmd_Submit('Exit');
	}
	return;
}

function iNmd_Disable(sId, nSts, sClass)
{	var oObj = i_Id(sId);
	if (oObj)
	{	oObj.disabled = nSts;
		if (sClass)	oObj.className = sClass;
	}
}

function iNmd_Lock(sId, nSts)
{	var oObj = i_Id(sId);
	if (oObj)
	{	if (nSts)
			oObj.readOnly = true;
		else
			oObj.readOnly = false;
	}
}

var oDivMbox;
var nMbxTimer;
var idMbxTimer = null;
var nBarSts = 0;
var nBarMax = -1;
var nBarCur = 0;

function iNmd_Msgbox(sHtml, nFocus, nTimer)
{	var oDiv = i_Id('pb_Bar');

	iNmd_MaskScrn();
	
	oDivMask.onclick = iNmd_NoKbd;
	
	oDivMbox = document.createElement('div');
	oDivMbox.className = 'iMbxDiv';
	oDivMbox.style.visibility = 'hidden';

	oDivMbox.innerHTML = sHtml;
	
	oDivMbox.style.position='absolute';
	oDivMbox.style.zIndex = 10;

	oDivMbox.style.left = '0px';
	oDivMbox.style.top = '0px';
	
	i_AddNode(oDivMbox);

	if (!oDiv)
	{	oDiv = i_Id('pb_Bar');
		if (oDiv)
		{	nBarMax = oDiv.offsetWidth;
			nBarCur = 0;
			oDiv.style.width = '1px';
			nBarSts = 0;
		}
	}
	
	
	setTimeout('iNmd_MbxSize('+nFocus+');',20);
	if (nTimer)
	{	nMbxTimer = nTimer;
		idMbxTimer = setInterval(iNmd_MbxTime,1000);
	}
}

function iNmd_MbxSize(nFocus)
{	if ((oDivMask.offsetWidth - oDivMbox.offsetWidth) < 100)
	{	if (oDivMask.offsetWidth > 500) 
			oDivMbox.style.width = (oDivMask.offsetWidth - 100) + 'px';
	}
	else
	if (oDivMbox.offsetWidth < 200) 
		oDivMbox.style.width = '200px';
	
	oDivMbox.style.left = Math.max(5, iNmd_Left(oDivMask) + ((oDivMask.offsetWidth - oDivMbox.offsetWidth) / 2)) + 'px';
	oDivMbox.style.top = Math.max(5,iNmd_Top(oDivMask) + ((oDivMask.offsetHeight - oDivMbox.offsetHeight) / 2)) + 'px';
	oDivMbox.style.visibility = 'visible';

	i_AddEvent(oDivMbox, 'mousedown', iNmd_MbxMseDwn, true);

	var oBtn = i_Id('mb_' + nFocus);
	if (oBtn) oBtn.focus();
}

var nMbxMseDwnX;
var nMbxMseDwnY;

function iNmd_MbxMseDwn(e)
{	if (window.event) e = window.event;
	var oDiv = (e.target ? e.target : e.srcElement);
	if (oDiv.id) return;

	i_AddEvent(window, 'mousemove', iNmd_MbxMseMove, true);
	i_AddEvent(oDivMbox, 'mouseup', iNmd_MbxMseUp, true);

	iNmd_MseXY(e);
	nMbxMseDwnX = nMseX - iNmd_Left(oDivMbox);
	nMbxMseDwnY = nMseY - iNmd_Top(oDivMbox);
	
	if (e.stopPropagation) e.stopPropagation();
	if (e.preventDefault) e.preventDefault();
	return e.returnValue = false;
}

function iNmd_MbxMseUp(e)
{	if (window.event) e = window.event;
	i_RmvEvent(window, 'mousemove', iNmd_MbxMseMove, true);
}

function iNmd_MbxMseMove(e)
{	if (window.event) e = window.event;

	iNmd_MseXY(e);
	
	oDivMbox.style.left = (nMseX - nMbxMseDwnX) + 'px';
	oDivMbox.style.top  = (nMseY - nMbxMseDwnY) + 'px';

	if (e.stopPropagation) e.stopPropagation();
	if (e.preventDefault) e.preventDefault();
	return e.returnValue = false;

}


function iNmd_MbxTime()
{	nMbxTimer--;
	if (nMbxTimer <= 0)
	{	iNmd_MbxDrop();
		AjxSend('C0,0',0);
		return;
	}
	
	var oText = i_Id('mb_timer');
	
	if (oText) 
	{	var nMn;
		var nSec;
		nSec = nMbxTimer % 60;
		nMn = (nMbxTimer - nSec) / 60;
		
		oText.innerHTML = nMn.toString(10) + ':' + (nSec + 100).toString(10).substr(1);
	}
}		

function iNmd_MbxClk(e)
{	var	oBtn = e.target ? e.target :  e.srcElement;
    var sBtn = oBtn.id.substr(3);
    
    oMbxBtn = null;
    oMbxFcs = false;
    
	if (oDivMbox)
	{	iNmd_MbxDrop();
		AjxSend('C' + sBtn + ',0',0);
	}
	else
	{	iNmd_Submit(sBtn);
	}
	
	e.returnValue = false;			
	return false;
}

function iNmd_MbxDrop()
{	oMbxBtn = null;
    oMbxFcs = false;
    
	if (oDivMbox)
	{	i_RmvEvent(oDivMbox, 'mousedown', iNmd_MbxMseDwn, true);
		i_RmvEvent(oDivMbox, 'mouseup', iNmd_MbxMseUp, true);

		oDivMbox.parentNode.removeChild(oDivMbox);
		oDivMbox = null;

		if (idMbxTimer)
		{	clearInterval(idMbxTimer);
			idMbxTimer = null;
		}
	}
			
	iNmd_UnMask();
}

var oMbxBtn = null;
var oMbxFcs = false;

function iNmd_MbxFcs(e)
{	oMbxBtn = e.target ? e.target : e.srcElement;
	oMbxFcs = true;
	return;
}
function iNmd_MbxBlr(e)
{	oMbxFcs = false;
	setTimeout(iNmd_MbxChkFcs, 100);
}
function iNmd_MbxChkFcs()
{	if (oDivMbox)
	{	if (!oMbxFcs)
		{	try
			{	oMbxBtn.focus(); 
				setTimeout(iNmd_MbxChkFcs, 500);
			}
			catch(err) { } 
		}
	}
}

function iNmd_PrgBar(sText, nPct)
{	if (nPct < -1) 
	{	iNmd_MbxDrop();
		return;
	}
	
	var oText = i_Id('pb_Text');
	if (oText) oText.innerHTML = sText;
	
	var oDiv = i_Id('pb_Bar');
	if (oDiv)
	{	if (nPct == -1) 
		{	nPct = nBarCur + 5;
			if (nPct > 100) nPct = 5;
		}
		nBarCur = Math.min(100,nPct);
		nPct = ((nBarCur * nBarMax) / 100);
		oDiv.style.width = nPct + 'px';
	}
	
	AjxSend('C' + nBarSts + ',0', -1);
	return;
}

function iNmd_PbrClk(e)
{	nBarSts = 1;
	if (window.event) e.returnValue = false;
	return false;
}

function iNmd_MaskScrn()
{	var oDiv = document.createElement('div');

	oDiv.i_next = oDivMask;
	oDiv.i_mbox = oDivMbox;

	oDivMbox = null;
	oDivMask = oDiv;
	
	oDivMask.style.position='absolute';

	oDivMask.style.left = 0;
	oDivMask.style.top = 0;

	iNmd_GetSize()
		
	oDivMask.style.width = wdwWd + 'px';
	oDivMask.style.height = wdwHi + 'px';

	oDivMask.className = 'iCmnMask';
	
	i_AddNode(oDivMask);

	oDivMask.innerHTML = "<a class='iCmnVal' id='id_Dead' href='#' onkeydown='iNmd_NoKbd(event);' onkeyup='iNmd_NoKbd(event);'>&nbsp;</a>";	
	i_Id('id_Dead').focus();
	return;
}
function iNmd_UnMask()
{	if (oDivMask)
	{	oDivMbox = oDivMask.i_mbox;
		var oDiv = oDivMask.i_next;

		oDivMask.parentNode.removeChild(oDivMask);
		oDivMask = oDiv;

		if (oFcs && !oDivMask)
		{	bIgnoreFcs = 1;
			if (oFcs.focus)
			{	try { oFcs.focus(); }
				catch(err) { bIgnoreFcs = 0; } 
			}
		}
	}
}

function iNmd_NoKbd(e)
{	if (window.event) e = window.event;
	if (e.stopPropagation) e.stopPropagation();
	if (e.preventDefault) e.preventDefault();
	e.cancelBubble = true;
    e.cancel = true;
	e.returnValue = false;
	return false;
}

/* Calculator */

var oDivCalc = null;

var oVal = null;

function iClc_Pop(sId)
{	var oObj = i_Id(sId);
	if (oObj) iClc_do(oObj);
}

function iClc_do(oQry)
{	var sId = oQry.id;
	var oObj;
	var sVal;
	
	if (sId.substr(0,2) == 'gc')
	{	oObj = oQry;
		sVal = i_Text(oObj);
	}
	else
	{	oObj = i_Id('id_' + sId.substr(3));
		sVal = oObj.value;
	}
	
	if (window.event) window.event.returnValue = false;
	if (!oObj) return false;
	if (oObj.disabled) return false;
	
	var nTop = iNmd_Top(oObj) + oObj.offsetHeight;
	var nLeft = iNmd_Left(oObj);
	
	iNmd_MaskScrn();
	oDivMask.onclick = iClc_Exit;
	
	oDivCalc = document.createElement('div');
	oDivCalc.className = 'iClcDiv';

	oDivCalc.innerHTML =
		"<table class='iClcFrame'><tr><td>" +
		"<table class='iClcBtns'>" +
		"<tr><td colspan='4'><input id='ic_Val' class='iClcInp' type='text' name='Val'></div></td>" +
		"<td id='ic_Rtrn' class='iClcBtn' onclick='iClc_Rtrn();'>&nbsp;</td>" +
		"<td id='ic_Exit' class='iClcBtn' onclick='iClc_Exit();'>&nbsp;</td></tr>" +
		"<tr><td class='iClcBtn' onclick='iClc_Dig(\"1\");'>1</td>" +
		"<td class='iClcBtn' onclick='iClc_Dig(\"2\");'>2</td>" +
		"<td class='iClcBtn' onclick='iClc_Dig(\"3\");'>3</td>" +
		"<td>&nbsp</td>" +
		"<td class='iClcBtn' onclick='iClc_Opr(\"+\");'>+</td>" +
		"<td class='iClcBtn' onclick='iClc_Fnc(\"1/\");'>1/x</td></tr>" +
		"<tr><td class='iClcBtn' onclick='iClc_Dig(\"4\");'>4</td>" +
		"<td class='iClcBtn' onclick='iClc_Dig(\"5\");'>5</td>" +
		"<td class='iClcBtn' onclick='iClc_Dig(\"6\");'>6</td>" +
		"<td>&nbsp</td>" +
		"<td class='iClcBtn' onclick='iClc_Opr(\"-\");'>-</td>" +
		"<td class='iClcBtn' onclick='iClc_Fnc(\"0-\");'>+/-</td></tr>" +
		"<tr><td class='iClcBtn' onclick='iClc_Dig(\"7\");'>7</td>" +
		"<td class='iClcBtn' onclick='iClc_Dig(\"8\");'>8</td>" +
		"<td class='iClcBtn' onclick='iClc_Dig(\"9\");'>9</td>" +
		"<td>&nbsp</td>" +
		"<td class='iClcBtn' onclick='iClc_Opr(\"*\");'>x</td>" +
		"<td class='iClcBtn' onclick='iClc_Fnc(\"Math.sqrt\");'>&radic;</td></tr>" +
		"<tr><td class='iClcBtn' onclick='iClc_Clr();'>c</td>" +
		"<td class='iClcBtn' onclick='iClc_Dig(\"0\");'>0</td>" +
		"<td class='iClcBtn' onclick='iClc_Dig(\".\");'>.</td>" +
		"<td>&nbsp</td>" +
		"<td class='iClcBtn' onclick='iClc_Opr(\"/\");'>/</td>" +
		"<td class='iClcBtn' onclick='iClc_Fnc(\"\");'>=</td></tr></table>" +
		"</td></tr></table>";
		
	oDivCalc.style.position='absolute';
	oDivCalc.style.top = nTop + 'px';
	oDivCalc.style.left = nLeft + 'px';
	
	i_AddNode(oDivCalc);
	
	oDivCalc.in_obj = oObj;

	oVal = i_Id('ic_Val');
	
	if (sVal)
	{	var cVal;
		for (var n = 0; n < sVal.length; n++)
		{	cVal = sVal.substr(n,1);
			if ('0123456789.-+'.indexOf(cVal) != -1) oVal.value += cVal;
		}
	}
	
	oVal.in_sts = 1;
	oVal.onkeypress = iClcEvt;
	oVal.onkeydown = iClcEvt;
	
	iClc_Fcs(oVal);
	
	return false;
}

function iClcEvt(e)
{	var cKey;
	
	if (window.event) e = window.event;
	if (e.type == 'keypress')
	{	cKey = (!iNmd_is_ie) ? e.which : e.keyCode;
		
		if (cKey == 13) 
		{	if (oVal.in_sts)
				iClc_Rtrn();
			else
				iClc_Fnc('');
		}
		else
		if (cKey == 27)
			iClc_Exit();
		else
		if (cKey != 9)
		{	oVal.in_sts = 0;
			 return true;
		}
	}
	
	if (e.type == 'keydown')
	{	cKey = (!iNmd_is_ie) ? e.which : e.keyCode;
		if (cKey != 9) return true;
	}
	
	if (e.stopPropagation) e.stopPropagation();
	if (e.preventDefault) e.preventDefault();
	e.cancelBubble = true;
    e.cancel = true;
	e.returnValue = false;
	return false;
}


function iClc_Dig(sDig)
{	if (oVal.in_sts) iClc_Clr();

	oVal.in_sts = 0;
	oVal.value += sDig;
		
	iClc_Fcs(oVal);
	if (iNmd_is_ie) 
	{	window.event.srcElement.ondblclick = Function('iClc_Dig("' + sDig + '");');
	}
}

function iClc_Clr()
{	oVal.value = '';
	oVal.className = 'iClcInp';
	oVal.in_sts = 0;
		
	iClc_Fcs(oVal);
}

function iClc_Opr(sOpr)
{	if (oVal.className != 'iClcInp') return;
 
 	oVal.in_sts = 0;
	oVal.value += ' '+ sOpr + ' ';
	iClc_Fcs(oVal);
}

function iClc_Fnc(sOpr)
{	if (oVal.value.toUpperCase() != oVal.value.toLowerCase())
	{	oVal.className = 'iClcErr';
	}
	else	
	try
	{	oVal.value = eval( sOpr + '(' + oVal.value + ')');

		if (isFinite(oVal.value))
			oVal.className = 'iClcInp';	
		else
			oVal.className = 'iClcErr';
	}
	catch(err)
	{	oVal.className = 'iClcErr';
	}
	
	oVal.in_sts = 1;
	iClc_Fcs(oVal);
}

function iClc_Fcs(oObj)
{	oObj.focus();
	
	var nLen = oObj.value.length;
	if (nLen == 0) return;
	
	if ((document.selection) && (!bOpera))
	{	var oRng = document.selection.createRange();
		if (oRng)
		{	oRng.moveStart("character", nLen);
			oRng.moveEnd("character", nLen);
			oRng.select();
		}
	}
	else
	{	if ('selectionStart' in oObj)
		{	oObj.selectionStart = nLen;
			oObj.selectionEnd = nLen;
		}
	}
	return;
}
function iClc_Rtrn()
{	iClc_Fnc('');
	if (oVal.className != 'iClcInp') return;
	
	var oObj = oDivCalc.in_obj;
	var sVal = oVal.value;
	
	iClc_Exit();
	
	if (oObj.id.substr(0,2) == 'gc')
		AjxSend('S' + oObj.id.substr(3,5) + ',Chg:0,' + sVal, 0);
	else
	{	oObj.value = sVal;
		AjxSend('C' + oObj.id.substr(3) + ',0:' + sVal, 0);
	}
}

function iClc_Exit()
{	oVal = null;
	oDivCalc.parentNode.removeChild(oDivCalc);
	oDivCalc = null;
			
	iNmd_UnMask();
}

/* Date/Calendar */

var oDivDate = null;
var nMo, nYr, nDy;
var mxDy = 31;

function iDte_do(oQry)
{	if (window.event) window.event.returnValue = false;

	iDte_Pop('id_' + oQry.id.substr(3), 'CYMD');
	return false;
}

function iDte_Pop(sId, sDteFmt)
{	var oObj = i_Id(sId);
	if (!oObj) { alert('Cannot find ' + sId); return; }

	if (oObj.disabled) return;

	if (oFcs != oObj) oObj.focus();
	
	var nTop = iNmd_Top(oObj) + oObj.offsetHeight;
	var nLeft = iNmd_Left(oObj);

	iNmd_MaskScrn();

	oDivMask.onclick = iDte_Exit;
	oDivMask.innerHTML = "<input id='id_Dead' class='iCmnVal' type='text' onkeydown='iDte_Evt(event);' onkeyup='iDte_Evt(event);'>";
	
	oDivDate = document.createElement('div');
	oDivDate.className = 'iDteDiv';

	if (sId.substr(0,2) == 'gc')
		iDte_Load(i_Text(oObj));
	else
		iDte_Load(oObj.value);
		
	oDivDate.innerHTML = iDte_Html(nYr, nMo, nDy);

	oDivDate.style.position='absolute';
	oDivDate.style.top = nTop + 'px';
	oDivDate.style.left = nLeft + 'px';
	
	i_AddNode(oDivDate);
	
	oDivDate.in_obj = oObj;
	oDivDate.in_dead = i_Id('id_Dead');
	iDteDead();
	
	oDivDate.in_fmt = sDteFmt;
	return;
}

function iDteDead()
{	if (oDivDate) oDivDate.in_dead.focus();
	return false;
}

function iDte_Evt(e)
{	if (window.event) e = window.event;

	if (e.type != 'keydown') { iDteDead(); return iNmd_NoKbd(e); }
	var cKey = (!iNmd_is_ie) ? e.which : e.keyCode;

	switch(cKey)
	{	case 40:	/* Down arrow */
			if ((e.ctrlKey || e.shiftKey))
			{	nYr++;
				break;
			}
			nDy += 6;
		case 39:	/* Rght arrow */
			nDy++;
			if (nDy <= mxDy) break;
			nDy -= mxDy;
		case 33:	/* Page up */
			if (nMo >= 12) 
			{	nMo = 1; nYr++; }
			else
			{	nMo++; }
			break;

		case 38:	/* Up arrow */
			if ((e.ctrlKey || e.shiftKey))
			{	nYr--;
				break;
			}
			nDy -= 6;
		case 37:	/* Back arrow */
			nDy--;
			if (nDy > 0) break;

		case 34:	/* Page dn */
			if (nMo <= 1) 
			{	nMo = 12; nYr--; }
			else
			{	nMo--; }
			break;
			
		case 27:	/* Escape */
			iDte_Exit();
			return;

		case 13:	/* Return */
			iDteClk(0);
			return true;

		default:
			return;
	}
	oDivDate.innerHTML = iDte_Html(nYr, nMo, nDy);

	return iNmd_NoKbd(e);
}

function iDte_Html(nwYr, nwMo, nwDy)
{	nYr = nwYr;
	nMo = nwMo;

	if ((nwMo == 1) || (nwMo == 3) || (nwMo == 5) || (nwMo == 7) ||(nwMo == 8) || (nwMo == 10) || (nwMo == 12))
		mxDy = 31;
	else
	if (nwMo != 2)
		mxDy = 30;
	else
	if ((nwYr%4) != 0)
		mxDy = 28;
	else
		mxDy = 29;
	
	if (nwDy <= 0)
		nwDy = mxDy + nwDy;
	else
	if (nwDy > mxDy)
		nwDy = mxDy;

	nDy = nwDy;
	
	nwMo--;
	
	var oDt = new Date(nwYr, nwMo, 1);
	oDt.setTime(oDt.getTime() - (86400000 * oDt.getDay()));

	var sHtml = "<table class='iDteTbl'>";
	sHtml += "<tr class='iDteHdr'><td class='iDteDay'><div class='iDteArw' onclick='iDtePrv();'>&laquo;<div></td>";
	sHtml += "<td colspan='5' class='iDteMon'>" + 
		"<span onclick='iDteMo(event);'>" + window.in_mths[nwMo] + "</span> " +
		"<span onclick='iDteYr(event);'>" + nYr+"</span></td>";
	sHtml += "<td class='iDteDay'><div class='iDteArw' onclick='iDteNxt();'>&raquo;</div></td></tr>";
	
	var oToday = new Date();
	var nToday = -1;
	
	if ((oToday.getMonth() == nwMo) && (oToday.getFullYear() == nwYr))
		nToday = oToday.getDate();

	var sWrk = '<tr>';
	var d;
	var n;
		
	for (n=0; n<7; n++)
	{	sWrk += "<th class='iDteDay' onclick='iDteDead();'><div class='iDteOky'>"+window.in_wkdy.charAt(n)+"</div></th>";
	}
	sHtml += sWrk + '</tr>';
	
	for (var nLin=6; nLin>0; nLin--)
	{	sHtml+="<tr>";
	
		for (n=7; n>0; n--)
		{	d = oDt.getDate();
		
			if (oDt.getMonth() != nwMo)
				sWrk = "<div class='iDteBad' onclick='iDteDead();'>" + d + "</div>";
			else
			{	if (d == nwDy)
					sWrk = "iDteSel";
				else
				if (d == nToday)
					sWrk = "iDteNow";
				else
					sWrk = "iDteOky";
				
				sWrk = "<div class='" + sWrk + "' onclick='iDteClk(" + d + ");'>" + d + "</div>";
			
			}
			sHtml +=  "<td class='iDteDay'>" + sWrk + "</td>";
			oDt.setDate(d + 1);

		}
		sHtml+="</tr>"
	}
	return sHtml+"</table>";
}

var oDteDiv = null;

function iDteMo(e)
{	if (window.event) e = window.event;

	var sHtml = "";
	var n = nMo - 1;
	for (var i = 0; i < 12; i++)
	{	sHtml += "<option" + ((i == n) ? " selected='yes' " : "") + " value='" + i + "'>" + window.in_mths[i] + "</option>";
	}
	iDteDrp(e, sHtml);
	return;
}

function iDteYr(e)
{	if (window.event) e = window.event;

	var sHtml = "";
	for (var i = nYr - 50; i < (nYr + 50); i++)
	{	sHtml += "<option" + ((i == nYr) ? " selected='yes' " : "") + " value='" + i + "'>" + i + "</option>";
	}
	iDteDrp(e, sHtml);
	return;
}

function iDteDrp(e, sHtml)
{	if (oDteDiv)
	{	oDteDiv = i_RmvNode(oDteDiv);
		return;	
	}
	
	var oSpan = e.target ? e.target : e.srcElement;
	var oDteDiv = document.createElement('div');
	
	oDteDiv.className = 'iGridDrop';

	oDteDiv.style.position='absolute';
	oDteDiv.style.zIndex = 10;

	oDteDiv.style.top = iNmd_Top(oSpan) - iNmd_Top(oDivDate) + 'px';
	oDteDiv.style.left = iNmd_Left(oSpan) - iNmd_Left(oDivDate) + 'px';

	sHtml = "<select id='dt_list' size='7' class='iGridList'" +
			" onclick='iDteDrpExit();' " +
			" onblur='iDteDrpExit();'>" + 
			sHtml + "</select>"; 
	
	oDteDiv.innerHTML = sHtml;

	i_AddNode(oDteDiv, oDivDate);
	
	var oLst = i_Id('dt_list');
	oLst.focus();
	oLst.scrollTop = (oLst.selectedIndex * (1 + oLst.scrollHeight)) / oLst.length;
}

function iDteDrpExit(e)
{	var n = parseInt(i_Id('dt_list').value,10);
	if (n < 12) 
		nMo = n + 1;
	else
		nYr = n;

	oDivDate.in_dead.focus();
	oDivDate.innerHTML = iDte_Html(nYr, nMo, nDy);

	oDteDiv = i_RmvNode(oDteDiv);
	return;
}

function iDtePrv()
{	nMo--;
	if (nMo == 0)
	{	nYr--;
		nMo = 12;
	}

	oDivDate.innerHTML = iDte_Html(nYr, nMo, nDy);
	if (iNmd_is_ie) window.event.srcElement.ondblclick = Function('iDtePrv();');
	oDivDate.in_dead.focus();
}

function iDteNxt()
{	nMo++;
	if (nMo > 12)
	{	nYr++;
		nMo = 1;
	}

	oDivDate.innerHTML = iDte_Html(nYr, nMo, nDy);
	if (iNmd_is_ie) window.event.srcElement.ondblclick = Function('iDteNxt();');
	oDivDate.in_dead.focus();
}

function iDteClk(nwDy)
{	if (nwDy != 0) nDy = nwDy;

	var oObj = oDivDate.in_obj;
	var sFmt = oDivDate.in_fmt;
	if (!sFmt) sFmt = 'CYMD';

	nMo += 100;
	nDy += 100;

	var sYr = nYr.toString(10);
	var sMo = nMo.toString(10);
	var sDy = nDy.toString(10);
	
	sVal = '';
	for (var n = 0; n < sFmt.length; n++)
	{	var cFmt = sFmt.substr(n,1);
		if (cFmt == 'C')
			sVal += sYr.substr(0,2);
		else
		if (cFmt == 'Y')
			sVal += sYr.substr(2,2);
		else
		if (cFmt == 'M')
			sVal += sMo.substr(1);
		else
		if (cFmt == 'D')
			sVal += sDy.substr(1);
		else
			sVal += cFmt;
	}

	if (typeof user_DateOut == 'function') sVal = user_DateOut(sVal);
	
	iDte_Exit();
	
	if (oObj.id.substr(0,2) == 'gc')
		AjxSend('S' + oObj.id.substr(3,5) + ',Chg:0,' + sVal, 0);
	else
	{	oObj.value = sVal;
		AjxSend('C' + oObj.id.substr(3) + ',0:' + sVal, 0);
	}
}

function iDte_Exit()
{	var oObj = oDivDate.in_obj;

	oDivDate.parentNode.removeChild(oDivDate);
	oDivDate = null;
		
	iNmd_UnMask();
	oObj.focus();
}

function iDte_Load(sVal)
{	nMo = nYr = nDy = -1;

	var nOfst;
	var sFld = "";
	var cFld;
	var sType;
	var nFld;

	var oDt = new Date();

	var n = 0;
	
	if (typeof user_DateIn == 'function')
	{	var sVal2 = user_DateIn(sVal);
		if (sVal2)
		{	nYr = parseInt(sVal2.substr(0,4));
			nMo = parseInt(sVal2.substr(4,2));
			nDy = parseInt(sVal2,substr(6,2));
			return;
		}
	}
	
	for (var f=0; f < 3; f++)
	{	if (n >= sVal.length) break;
	
		sFld = "";
		sType = "";
		
		for (; n < sVal.length; n++)
		{	cFld = sVal.charAt(n);
		
			if ((cFld >= '0') && (cFld <= '9'))
			{	if (sType != 'S')
				{	sFld += cFld;
					sType = 'N';
					continue;
				}
				break;
			}
			else
			if (sType == 'N') break;
			
			cFld = cFld.toUpperCase();

			if ((cFld >= 'A') && (cFld <= 'Z'))
			{	if (sType != 'N')
				{	if (sFld.length < 3) sFld += cFld;
					sType = 'S';
					continue;
				}
				break;
			}
			else
			if (sType == 'S') break;
			
		}
		
		if (sType == 'S')
		{	if (sFld.length != 3) break;
			if (nMo != -1)
			{	if (nDy == -1)
					nDy = nMo;
				else
				if (nYr == -1)
					nYr = nMo;
				else
					break;
			}
				
			for (nMo = 11; nMo >= 0; nMo--)
			{	if (sFld == window.in_mths[nMo].substr(0,3).toUpperCase()) 
				{	nMo++;
					break;
				}
			}
			continue;
		}
		
		if (f == 0)
		{	if (sFld.length == 6)
			{	nFld = parseInt(sFld.substr(0,2),10);
				if (nFld > 31) 
				{	nYr = nFld;
					nDy = parseInt(sFld.substr(2,2), 10);
				}
				else
				{	nDy = nFld;
					nYr = parseInt(sFld.substr(2,2), 10);
				}
				nMo = parseInt(sFld.substr(2,2), 10);
				break;
			}

			if (sFld.length == 8)
			{	nYr = parseInt(sFld.substr(0,4), 10);
				if ((nYr > 1800) && (nYr < 2100)) 
				{	nDy = parseInt(sFld.substr(6),10);
					nMo = parseInt(sFld.substr(4,2), 10);
				}
				else
				{	nDy = parseInt(sFld.substr(0,2),10);
					nMo = parseInt(sFld.substr(2,2), 10);
					nYr = parseInt(sFld.substr(4,4), 10);
				}
				
				break;
			}
		}
				
		nFld = parseInt(sFld,10);
		if (nFld == 0) break;
		
		if ((nFld > 31) && (nFld < 9999))
		{	nYr = nFld;
			continue;
		}
		
		if ((nDy == -1) && (nFld > 12))
		{	nDy = nFld;
			continue;
		}
		
		if ((nMo == -1) && (nFld <= 12))
		{	nMo = nFld;
			continue;
		}
		
		if (nDy == -1)
			nDy = nFld;
		else
		if (nMo == -1)
			nMo = nFld;
		else
			nYr = nFld;	
	}
	
	if (nYr == -1)
	{	nYr = oDt.getFullYear();
	}
	else
	if (nYr < 100)
	{	if (nYr > 50)	
			nYr += 1900;
		else
			nYr += 2000;
	}
	
	if (nMo == -1) nMo = oDt.getMonth() + 1;
	if (nDy == -1) nDy = oDt.getDate();
	
	return;
}
	
/* Ajax logic interfaces */

var AjxSts = 0;
var AjxSend1 = "";
var AjxSend2 = "";
var AjxSend3 = "";
var AjxSend4 = "";
var AjxResp1 = "";
var AjxResp2 = "";
var AjxResp3 = "";
var AjxResp4 = "";

var AjxSeq = 0;

function AjxSend(cmd, waitInd)
{	var xmlHttp;
	var bAsync;
	var idTimer;
	var bPend;
	var bSent;

	if (bIdleReqd)
	{	bIdleReqd = false;
		AjxSend('I', 1);
	}

/*
	if (oDivMbox && (waitInd >= 0)) return true;
*/	
	if (AjxSts == -1) return false;
	if (nSubmit > 0)
	{	nSubmit--;
		return true;
	}
	
	if ((bSafari) && (waitInd == 0)) waitInd = 1;
	if ((bFireFox) && (waitInd == 0)) waitInd = 1;
	if (waitInd == 0) waitInd = 1;
	try
	{	xmlHttp=new XMLHttpRequest();
	}
	catch (e)
	{	try
		{	xmlHttp=new ActiveXObject("Msxml2.XMLHTTP");
		}
		catch (e)
		{	xmlHttp=new ActiveXObject("Microsoft.XMLHTTP");
		}
	}

	if (xmlHttp == null) 
	{	alert("AJax NEW failed");
		AjxSts = -1;
		return false;
	}

	idTimer = 0;
	bSent = false;

	xmlHttp.onreadystatechange = function()
	{	if (xmlHttp.readyState == 4)
		{	if (bPend || bAsync)
			{	bPend = false;
				if (idTimer)
				{	clearTimeout(idTimer);
					idTimer = 0;
				}
				AjxDo(xmlHttp);
			}
		}
	}
	
	if (waitInd > 0)
	{	bAsync = false;
		idTimer = setTimeout(function() { AjxBusy = false; xmlHttp.abort(); idTimer = 0;}, 30000);
		bPend = true;
	}
	else
	{	bAsync = true;
		bPend = false;
	}

	if (sFcsPend != '')
	{	cmd = '[' + sFcsPend + ']' + cmd;
		sFcsPend = '';
	} 
	
	++AjxSeq;
	xmlHttp.open('GET', window.location.pathname + 
				'?_session=' + document.inomads._session.value + 
				'&_seq=Ajax&_dta=' + encodeURIComponent(cmd) + '&_x=' + document.inomads._seq.value + AjxSeq , bAsync);

	AjxSend4 = AjxSend3;
	AjxResp4 = AjxResp3;

	AjxSend3 = AjxSend2;
	AjxResp3 = AjxResp2;
	
	AjxSend2 = AjxSend1;
	AjxResp2 = AjxResp1;

	AjxSend1 = cmd;
	AjxResp1 = "(pending)";

	xmlHttp.send(null);

	if (bPend) 
	{	if (idTimer)
		{	clearTimeout(idTimer);
			idTimer = 0;
		}

		AjxDo(xmlHttp);
	}

	return true; 
}

function AjxDo(xmlHttp)
{	nPoll = 0;
	bAjxDmp = false;
	
	if (bRefocus)
	{	bRefocus = false;
		if (oFcs) oFcs.focus();
	}
	
	if (xmlHttp.status != 200) 
	{	if (xmlHttp.status == 0) 
		{	LOG("Ajax sts=0: resp len=" + xmlHttp.responseText.length);
		}
		else
		{	alert('Data transmission to the server failed (sts=' + xmlHttp.status + ')');
			return;
		}
	}
	if (xmlHttp.responseText.length > 0) 
	{	AjxResp1 = xmlHttp.responseText;

		if (AjxResp1.substr(0,3) == 'Do:')
		{	var fncDo = new Function(AjxResp1.substr(3));
			fncDo();
		}
		else
		if (AjxResp1.substr(0,6) == '<html>')
		{   window.onunload = null;
			window.onbeforeunload = null;
			document.write(AjxResp1);
			document.close();
		}
		else
		if (AjxResp1.substr(0,3) != 'Ign')
		{	bIgnoreFcs = true;
			alert("Invalid Ajax resp=='" + AjxResp1 + "==");
		}
	}
	else
		AjxResp1 = '** sts:' + xmlHttp.status + ' **';
}

function LOG(s)
{	window.onresize = null;
	sLog += s + '<br>';

	if (!oStamp) oStamp = i_Id('iNmdScript'); 
	if (oStamp) oStamp.innerHTML += '<br>' + s;
}

var bAjxDmp = false;
 
function AjxDump()
{	bAjxDmp = true;
	var wNew = window.open('','','height=600,width=800,toolbar=no,directories=no,status=no,menubar=no,scrollbars=yes,resizable=yes,location=no');
	
	wNew.document.writeln('<html><body>');
	wNew.document.writeln('<div align="center" style="white-space: normal;">')
	wNew.document.writeln(sRev + '<br />');
	wNew.document.writeln('Mouse x/y:' + nMseX + '/' + nMseY + '<br />');
	
	var sLn = 'Focus on:';
	
	if (oFcs)
	{	sLn += oFcs.id + ' name=' + oFcs.name + ' sigexit=' + oFcs.in_sigexit;
		if (oChg) sLn += ' ** Change id=' + oChg.id + ' **';
	}
	else
	{	sLn += 'none';
	}
	
	wNew.document.writeln(sLn + '<br>');
	
	iNmd_GetSize();
	wNew.document.writeln('<br>Wdw: w/h=' + wdwWd + '/' + wdwHi +
			' Body: w/h=' + bdyWd + '/' + bdyHi +
			' Panel: w/h=' + pnlWd + '/' + pnlHi + '<br />');
			

	for (var n=0; n < aryDrags.length; n++)
	{	wNew.document.writeln('<br>Drag ' + aryDrags[n].idDrag + ' onto ' + aryDrags[n].idDrop + ' fires ' + aryDrags[n].nCtl);
	}
	
	wNew.document.writeln(sLog);
	sLog = '';
	
	if (nSubmit)
		wNew.document.writeln('Submit has been sent. Code: ' + sSubmit + ' [' + nSubmit + ']');
		
	wNew.document.writeln('</div>');
	wNew.document.writeln('<table border=1>');

	if (AjxSend4 != '')
	{	wNew.document.writeln('<tr><td valign=top>4rd last msg sent</td><td bgcolor="#80FF80">');
		AjxWrite(wNew,AjxSend4);
		wNew.document.writeln('</td></tr>');
		wNew.document.writeln('<tr><td valign=top>Response</td><td bgcolor="#80FF80">');
		AjxWrite(wNew,AjxResp4);
		wNew.document.writeln('</td></tr>');
	}

	if (AjxSend3 != '')
	{	wNew.document.writeln('<tr><td valign=top>3rd last msg sent</td><td bgcolor="#80FF80">');
		AjxWrite(wNew,AjxSend3);
		wNew.document.writeln('</td></tr>');
		wNew.document.writeln('<tr><td valign=top>Response</td><td bgcolor="#80FF80">');
		AjxWrite(wNew,AjxResp3);
		wNew.document.writeln('</td></tr>');
	}
	
	if (AjxSend2 != '')
	{	wNew.document.writeln('<tr><td valign=top>2nd last msg sent</td><td bgcolor="#80FF80">');
		AjxWrite(wNew,AjxSend2);
		wNew.document.writeln('</td></tr>');
		wNew.document.writeln('<tr><td valign=top>Response</td><td bgcolor="#80FF80">');
		AjxWrite(wNew,AjxResp2);
		wNew.document.writeln('</td></tr>');
	}
	
	wNew.document.writeln('<tr><td valign=top>Most recent</td><td bgcolor="#80FF80">');
	AjxWrite(wNew,AjxSend1);
	wNew.document.writeln('</td></tr>');
	wNew.document.writeln('<tr><td valign=top>Response</td><td bgcolor="#80FF80">');
	AjxWrite(wNew,AjxResp1);
	wNew.document.writeln('</td></tr>');

	wNew.document.writeln('</table>');
	wNew.document.writeln('</body></html>');
	wNew.document.close();
	return false;
}

function AjxWrite(oWdw, sText)
{	var sHtml = iNmd_HTML(sText);
	if (sHtml == '') sHtml = '{no data}';
	oWdw.document.writeln(sHtml);
}

function iNmd_HTML(sText)
{	var sHtml = sText.replace(/&/g, '&amp;');
	sHtml = sHtml.replace(/</g, '&lt;');
	sHtml = sHtml.replace(/>/g, '&gt;');
	return sHtml;
}

function AjxCtl(nCtl)
{ 	if (AjxSend('C' + nCtl + ',0', 0)) return false;
	iNmd_Submit(nCtl.toString(10));
	return false;
}

function AjxIdle()
{	bIdleReqd = true;
	setTimeout(AjxIdle2, 50);
}

function AjxIdle2()
{	if (bIdleReqd)
	{	bIdleReqd = false;
		AjxSend('I',1);
	}
}

function iNmd_MseXY(e)
{	if (e.pageX)
	{	nMseX = e.pageX
		nMseY = e.pageY
	}  
	else
	if (e.clientX)
	{	nMseX = e.clientX;
		nMseY = e.clientY;
		if (iNmd_is_ie)
		{	nMseX += document.body.scrollLeft; // -document.body.clientLeft;
			nMseY += document.body.scrollTop;// -document.body.clientTop;
		}
	}
		
}

var aryDrags = new Array();
var oDragMsk = null;
var oDragDiv = null;
var oDrag = null;
var oDrop = null;
var nDropX = 0;
var nDropY = 0;
var nDropCtl = 0;

function iNmd_DragDrop(idDrag, idDrop, nCtl)
{	for (var i = 0; i < aryDrags.length; i++)
	{	if ((aryDrags[i].idDrag == idDrag) & (aryDrags[i].idDrop == idDrop))
		{	if (nCtl != 0)
			{	aryDrags.nCtl = nCtl;
			}
			else
			{	aryDrags.splice(i,1);
				if (argDrags.length == 0) i_RmvEvent(window, 'mousedown', iNmd_MseDwn, true);
			}
			return;
		}
	}
	
	if (nCtl == 0) return;
	
	if (aryDrags.length == 0) i_AddEvent(window, 'mousedown', iNmd_MseDwn, true);
		
	aryDrags.push({idDrag:idDrag, idDrop:idDrop, idDiv:'', nCtl:nCtl, top:0, left:0, width:-1, hieght:-1});
	return;
}

function iNmd_MseDwn(e)
{	if (bResize) return;
	if (window.event) e = window.event;
	if (e.ctrlKey || e.shiftKey) return;

	if (oDragDiv)
	{	oDrag = oDrop = null;
		iNmd_MseUp(e);
		return;
	}
	
	oDrag = null;
	
	var oOver = e.target ? e.target : e.srcElement;

	if (oOver.disabled) return;
	
	while (oOver)
	{	if (oOver.id) break;
		oOver = oOver.parentNode;
	}
	if (!oOver) return;
	
	if (oOver.id.substr(0,3) == 'gf_') return;
	
	if ((oOver.id.substr(0,3) == 'gc_') && (oOver.id.indexOf('N') == -1)) return;
	
	if (oOver.type)
	{	if (oOver.type == 'text')
		{	if (iNmd_is_ie)
			{	if (document.selection.createRange().text.length != 0) return;
			}
			else
			{	if (oOver.selectionEnd > oOver.selectionStart) return;	
			}
		}
		else
		if (oOver.options)
		{	iNmd_MseXY(e);		/* Avoid Lbx scrollbar */
			if (nMseX > (iNmd_Left(oOver) + oOver.offsetWidth - 20)) return;
		}
	}
	
	idDrag = oOver.id;
	if ((idDrag.substr(0,1) == 's') || (idDrag.substr(0,1) == 'd') || (idDrag.substr(0,1) == 'v')) return;
			
	idDrag = idDrag.substr(3);
	
	var nOfs = idDrag.indexOf('_');
	if (nOfs > 0) idDrag = idDrag.substr(0,nOfs);

	for (var i = 0; i < aryDrags.length; i++)
	{	if (aryDrags[i].idDrag == idDrag)
		{	aryDrags[i].left = 1000000;
		
			oDrop = i_Id('id_' + aryDrags[i].idDrop);
			if (!oDrop) continue;
			if (oDrop.disabled) continue;
			
			if ((oDrop.className == 'iCmnVal') || (oDrop.type == 'hidden'))
			{	oDrop = i_Id('dw_' + aryDrags[i].idDrop);
				if (!oDrop) oDrop = i_Id('dv_' + aryDrags[i].idDrop);
				if (!oDrop) continue;
			}

			aryDrags[i].idDiv = oDrop.id;
			aryDrags[i].top = iNmd_Top(oDrop);
			aryDrags[i].left = iNmd_Left(oDrop);
			aryDrags[i].width = oDrop.offsetWidth;
			aryDrags[i].height = oDrop.offsetHeight;

			oDrag = oOver;
		}
	}
	
	oDrop = null;
	if (!oDrag) return;
	oDrag.focus();

	iNmd_GetSize();
	
	i_AddEvent(window, 'mouseup', iNmd_MseUp, true);
	i_AddEvent(window, 'mousemove', iNmd_MseMve, true);		
	return;	
}

function iNmd_MseMve(e)
{	if (window.event) e = window.event;
	if (!oDrag) return;
	
	iNmd_MseXY(e);
	
	if (!oDragMsk)
	{	oDragMsk = document.createElement('div');
		oDragMsk.className = 'iDragMsk';
		oDragMsk.id = 'id_DragMsk';
				
		oDragMsk.style.position = 'absolute';

		oDragMsk.style.left = '0px';
		oDragMsk.style.top = '0px';
		oDragMsk.style.width = wdwWd + 'px';
		oDragMsk.style.height = wdwHi + 'px';

		i_AddNode(oDragMsk);

		oDragDiv = document.createElement('a');
		oDragDiv.className = 'iDragDiv';
		
		oDragDiv.style.position = 'absolute';
		oDragDiv.style.left = nMseX + 5 + 'px';
		oDragDiv.style.top = nMseY + 5 + 'px';
		
		i_AddNode(oDragDiv);

		oDrag.blur();		
		oDragDiv.focus();
		
		setTimeout(iNmd_DrgSet, 50);
		
		if (iNmd_is_ie)
		{	var newEvt = document.createEvent("MouseEvents");
			newEvt.InitEvent("mouseup", true, true);
			oDrag.dispatchEvent(newEvt);
		}


	}
	else
	{	if (!oDragDiv) return;
		oDragDiv.style.left = nMseX + 5 + 'px';
		oDragDiv.style.top = nMseY + 5 + 'px';
	}

	if (e.stopPropagation) e.stopPropagation();
	if (e.preventDefault) e.preventDefault();
	e.cancelBubble = true;
    e.cancel = true;
	e.returnValue = false;

	oDrop = null;
	nDropCtl = 0;

	for (var i = 0; i < aryDrags.length; i++)
	{	if (aryDrags[i].idDrag != idDrag) continue;
	
		nDropX = nMseX - aryDrags[i].left;
		nDropY = nMseY - aryDrags[i].top;
		
		if ((nDropX < 0) || (nDropX > aryDrags[i].width)) continue;
		if ((nDropY < 0) || (nDropY > aryDrags[i].height)) continue;
		
		oDrop = i_Id(aryDrags[i].idDiv);
		nDropCtl = aryDrags[i].nCtl;
		break;

	}
	
	if (oDrop)
	{	if (oDragDiv.className == 'iDragDiv')
		{	oDragDiv.className = 'iDropDiv';
			oDragMsk.style.cursor = 'default';
		}
	}
	else
	{	if (oDragDiv.className == 'iDropDiv')
		{	oDragDiv.className = 'iDragDiv';
			oDragMsk.style.cursor = 'wait';
		}
	}
	return false;
}

function iNmd_MseUp(e)
{	if (window.event) e = window.event;

	i_RmvEvent(window, 'mouseup', iNmd_MseUp, true);
	i_RmvEvent(window, 'mousemove', iNmd_MseMve, true);		

	if (oDrag && oDragDiv && oDrop && oDragMsk)
	{	AjxSend('D' + oDrag.id + ',' + iNmd_DrpOn(oDrop), -1);
	}

	oDrop = oDrag = null;
	
	oDragDiv = i_RmvNode(oDragDiv);
	oDragMsk = i_RmvNode(oDragMsk);
	
	return;
}

function iNmd_DrgSet()
{	if (!oDrag) return;

	if (oFcs == oDrag) oChg = oFcs;
	
	if (oChg) iNmd_Chg(oChg, 'U');
	
	var sVal = '';
	var oLbl;
	
	if (oDrag.type)
	{	if (oDrag.options)	/* Select */
		{	var nCnt = 0;
			for (var i = 0; i < oDrag.length; i++)
			{	if (!oDrag.options[i].selected) continue;
			
				nCnt++;
				if (nCnt > 1)
				{	sVal += '<br>';
				}
				if (nCnt > 4)
				{	sVal += '...';
					break;
				}
				sVal += oDrag.options[i].text;
			}
		}
		else
		{	oLbl = i_Id('lb' + oDrag.id.substr(2));
		
			if (oLbl) sVal = oLbl.innerHTML;
		}
		
	}	
	
	if (oDrag.id.substr(0,3) == 'lf_')
	{	oLbl = oDrag.parentNode;	
		while (oLbl)
		{	if (oLbl.id)
			{	sVal = '<table cellpadding=3><tr>' + oLbl.innerHTML + '</tr></table>';
				break;
			}
			oLbl = oLbl.parentNode;
		}
	}

	if (sVal == '')	sVal = oDrag.innerHTML;

	if (sVal == '')
	{	sVal = oDrag.value;
			
		if (sVal == '')
		{	sVal = oDrag.title;
			if (sVal == '') sVal = 'xxxxx...';
			sVal = '<i>'+sVal+'</i>';
		}
	}
		
	oDragDiv.innerHTML = sVal;
}

function iNmd_DrpOn(oOver)
{	if (!oOver) return;
	if (!oOver.id) return;
	var idOver = oOver.id;
	
	if (oOver.type && (oOver.type.substr(0,6) == 'select'))
	{	if (oOver.size > 1)
		{	var itemHeight = Math.floor(oOver.offsetHeight / oOver.size);
			var itemNo = Math.floor((nMseY - iNmd_Top(oOver) + oOver.scrollTop) / itemHeight);
			if ((itemNo >= 0) && (itemNo < oOver.length)) idOver += '_' + (itemNo + 1);
		}
	}
	else
	if (idOver.substr(0,3) == 'dw_')
	{	var sId = idOver.substr(3,5);
		
		var nScroll = 0;
		var oObj = i_Id('sh_' + sId);
		if (oObj) nScroll = oObj.scrollLeft;
		
		oObj = i_Id('tb_' + sId);
		if (oObj)
		{	idOver = iNmd_DrpItm(oObj, nScroll, idOver);
		}
		else
		{	oObj = i_Id('gh_' + sId);
			if (oObj)
			{	idOver = iNmd_DrpItm(oObj, 0, idOver);
				if (idOver == oOver.id)
				{	oObj = i_Id('gd_' + sId);
					if (oObj) idOver = iNmd_DrpItm(oObj, nScroll, idOver);
					
				}
			}
		}
	}
	return idOver;
}

function iNmd_DrpItm(oTbl, nScroll, idOver)
{	var y = nMseY - iNmd_Top(oTbl);
	var x = nMseX - iNmd_Left(oTbl) - nScroll;
	
	if ((y < 0) || (y > oTbl.offsetHeight)) return idOver;
	
	if ((x < 0) || (x > oTbl.offsetWidth)) return idOver;

	var oRow, oCol;

	for (var r = 0; r < oTbl.rows.length; r++)
	{	oRow = oTbl.rows[r];
		y -= oRow.offsetHeight;
		if (y <= 0) break;
	}
	if (y > 0) return idOver;
	
	for (var c = 0; c < oRow.cells.length; c++)
	{	oCol = oRow.cells[c];

		x -= oCol.offsetWidth;
		if (x <= 0) break;
	}
	if (oCol.id) 
		return oCol.id;
	else
		return idOver;
}

function iTch_Vbr(e)
{	if (window.event) e = window.event;
	
	var oObj = e.target ? e.target : e.srcElement;

	var oTm = new Date();
	var nMs = oTm.getTime();

	if (e.type == 'mousedown')
	{	oClick = oObj;
		nClickMS = nMs + 500;
		return false;
	}

	var nScr;

	if (e.type == 'click')
	{	iNmd_MseXY(e);
		if (oObj.id.substr(0,3) == 'vp_') oObj = i_Id('vb_' + oObj.id.substr(3));
				
		nScr = nMseY - iNmd_Top(oObj);
		if (nScr < 8) nScr = 0;				/* Fudge to make top easier to hit */
		nScr = (parseInt(oObj.getAttribute('iHi'), 10) * nScr ) / oObj.offsetHeight;
	}
	else
	{	var oDiv = i_Id('vb_' + oObj.id.substr(3));
	
		if (oObj.id.substr(0,2) == 'vu')
		{	if ((oClick == oObj) && (nClickMS < nMs))
				nScr = 0;
			else
			{	nScr = oDiv.in_ScrollTop - oDiv.offsetHeight + 10;
				if (nScr < 0) nScr = 0;
			}
		}
		else
		{	var nMax = parseInt(oDiv.getAttribute('iHi'), 10);
		
			if ((oClick == oObj) && (nClickMS < nMs))
				nScr = nMax;
			else
			{	nScr = oDiv.in_ScrollTop + oDiv.offsetHeight - 10;
				if (nScr > nMax) nScr = nMax;
			}
		}
	}

	AjxSend('S' + oObj.id.substr(3) + ',Vsc:' + nScr );
	return false;
}

/* Utility functions -- cross platform */

function i_AddNode(oNode, oParent)
{	if (!oParent) oParent = document.body;

	if (bOpera)
		oParent.insertBefore(oNode, oParent.childNodes[0]); 
	else
		oParent.appendChild(oNode);
}
function i_RmvNode(oNode)
{ 	if (oNode) oNode.parentNode.removeChild(oNode);
	return null;
}

function i_AddEvent(oObj, sEvent, fCode, fBubble)
{	if (oObj.addEventListener)
	{	oObj.addEventListener(sEvent, fCode, fBubble);
	}
	else
	{	if (oObj == window) oObj = document;
		oObj.attachEvent('on'+sEvent, fCode);
	}
}
function i_RmvEvent(oObj, sEvent, fCode, fBubble)
{	if (oObj.addEventListener)
	{	oObj.removeEventListener(sEvent, fCode, fBubble);
	}
	else
	{	if (oObj == window) oObj = document;
		oObj.detachEvent('on'+sEvent, fCode);
	}
}

function i_DblClk(oObj)
{	var oTm = new Date();
	var nMs = oTm.getTime();

	if ((oClick == oObj) && (nClickMS > nMs))
	{	nClickMS = 0;
		oClick = null;
		return true;
	}
	
	nClickMS = nMs + nDblClkMS;
	oClick = oObj;
	return false;
}

function i_Text(oObj)
{	if (bFireFox) 
		return oObj.textContent;
	else
		return oObj.innerText;
}

function i_Id(sId)
{	if (document.getElementById) return document.getElementById(sId);

	/* Manual hunt -- Needed for Pocket PC */

	for (var f = 0; f < document.forms.length; f++)
	{	var oForm = document.forms[f];
	  	
		for (var i = 0; i < oForm.length ; i++)
		{	if ( oForm.elements[i].id == sId)  return oForm.elements[i];
		}
	}
	alert('Cannot manually find:' + id);
	return null;
}

function iNmd_GetId(sId)
{	var oObj = iNmd_FindId(sId);
	if (oObj) return oObj;
	return document.inomads._seq;	/* Dummy */
}

function iNmd_FindId(sId)	/* Old name */
{	return i_Id(sId);
}

/* Upload routines */

function Upload_file(idForm)
{	window.onbeforeunload = null;
	window.onunload = null;
	i_Id(idForm).submit();
}
function Uptab_to(nId)
{	setTimeout("i_Id('mb_" + nId + "').focus();", 10);
}

/* Embed or Object ID */

function i_Obj(sName, sId)
{	if (document.embeds && document.embeds[sName])
		return document.embeds[sName];

	/* If second arg provided and non-null then its the ID else use name for both */
		
	if (sId)
		return i_Id(sId);
	else
		return i_Id(sName);
}

function i_Eval(sValu)
{	try
	{	AjxSend('=' + eval(sValu),0);
	}
	catch(e)
	{	AjxSend('=<!-- ' + e.message + ' -->',0);
	}
}
